// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Alambique.pov
// Vers: 3.5
// Descri: Um alambique tradicional, inspirado na miniatura, mercada na fortaleza de Valena do Minho,
               //que temos na minha casa.
// Data: XI-2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

#include "metals.inc"
#include "Alambique.inc"

global_settings{
  assumed_gamma 1
}

camera{
  //location<-.2,1,4>  //Anterior
  //location<-.2,1.6,-8>  //Posterior
  //location<-.2,3,-3>  //Prxima ao corpo, por arriba
  //location<6,2,2>  //Camp
  location<8,1.5,4>
  right 4/3*x
  up y
  direction 3*z
  //look_at .5*y  //Corpo
  look_at <0,1,.5>  //Camp
  //look_at 1.4*y
  //angle 7
  //rotate<0,-90,0>
  //translate ToQui
}

background{rgb<.01,0,.05>}

light_source{<60,20,80> rgb 1}

plane{y,0 pigment{checker}}

object{Alambique(false,20,100) texture{T_Copper_3C finish{ambient .05}}}  //Quedam-lhe bem vrios materiais e texturas.
                                                   //Quando se usar um material transparente, o primeiro
                                                   //parmetro da macro deve valer true, para substi-
                                                   //tuir vrias unions do objecto por merges. Lembre-
                                                   //-se activar, perto do comeo deste arquivo, as refe-
                                                   //rncias necessrias, e desactivar as que sobren para
                                                   //aforrar recursos.
/*#declare Caminho=spline{
    cubic_spline
    0, <0,1,0>,
    1, <0,.85,0>,
    2, <0,.75,0>,
    #local Conta=1/6;
    #while(Conta<=5.5)
      2+6*Conta, <.4*sin(2*pi*Conta),.75-Conta*.65/5.5,.4*(1-cos(2*pi*Conta))>,
      #declare Conta=Conta+1/6;
    #end
    36, <0,.1,1>,
    37, <0,.1,2>
}

#declare Tutulis=35*clock+1;
#local Delta_Tutulis=35*clock_delta;

#light_source{Caminho(Tutulis) rgb 1}
camera{
  fisheye
  location Caminho(Tutulis)
  look_at Caminho(Tutulis+Delta_Tutulis)
  angle 360
}*/

//#local PandaPunto=vnormalize(Caminho(Tutulis+Delta_Tutulis)-Caminho(Tutulis));
//cone{Caminho(Tutulis)+1.05*y-.1*PandaPunto, .1, Caminho(Tutulis)+1.05*y, 0 pigment{rgb<.6,0,1>}}