// Persistence of Vision Ray Tracer Scene Description File
// File: Black Sun with radiosity.pov
// Version: 3.6
// Description: A new version of Carsten Schmitz's "Sphere with holes and lights shining out of it"
// Creation date: 17-X-2004
// Last update: _
// Author: Xos B. Carballeira Rabual


//+w400 +h400

#version 3.6;


//------------------------------------------- OPTIONS ---------------------------------------------------

#declare NoHolesNS=12;
#declare NoHolesEW=12;
#declare HoleRadius=.03;


//-------------------------------------------- SCENE ----------------------------------------------------

global_settings{
  assumed_gamma 1
  /*radiosity{
    count 60
    error_bound .5
    media on
  }*/
}

camera{
  location<-.2,-1,-10>
  right x
  up y
  direction 3*z
  look_at 0
}

// Black Sun
light_source{
  0, rgb 2
  //area_light .998*x, .998*y 7, 7 adaptive 0 jitter circular orient
  media_attenuation on
  media_interaction on
}
difference{
  sphere{0, 1}
  sphere{0, .999}
  #declare CounterNS=0;
  #while(CounterNS<NoHolesNS)
    #declare CounterEW=0;
    #while(CounterEW<NoHolesEW)
      cylinder{
        .99*y, 1.01*y, HoleRadius rotate 180*CounterNS/NoHolesNS*z rotate 360*CounterEW/NoHolesEW*y
      }
      #declare CounterEW=CounterEW+1;
    #end
    #declare CounterNS=CounterNS+1;
  #end
  pigment{rgb 0}
}

// Media container
sphere{
  0, 1.4 hollow
  pigment{rgbt 1}
  interior{
    media{
      scattering{1, rgb 5}
      density{spherical scallop_wave scale 1.4}
      method 3
      intervals 1
      samples 4
      variance 1/512
      confidence .9
    }
  }
}