// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Buxaina II.pov
// Vers: 3.5
// Descri: Umha buxaina a rolar.
// Data de cria: 7-XII-2002
// Data da ltima actualiza: 8-V-2003
// Autor: Xos B. Carballeira Rabual

#version 3.5;

//-------------------------------------- Opes e ajustes ------------------------------------------------

//#declare Xose_PastaTemp=""  //Pasta na que se armazenarm os dados temporais, em arquivos .xose.
                                  //Convm estabelec-la: doutro jeito, usar-se- a pasta actual, que pode-
                                  //ria mudar dum quadro a outro, o que causaria perdas na informa
                                  //transmitida entre estes; isto provoca, s vezes, saltos anti-naturais
                                  //dos objectos, ou mesmo erros no traado, talvez porque a magnitude
                                  //dos chimpos desafia a capacidade de clculo do sistema.  hora de es-
                                  //crever o nome da pasta, deve lembrar-se que para significar umha \,
                                  //h que escrever duas \\ nas seqncias de texto do POV-Ray, j
                                  //que a contrabarra  o primeiro carcter de todas as claves de text
                                  //formatting (v. manual na tela, sec 6.2.7.2). O arquivo
                                  //Xose.inc assigna a estes fins umha pasta predeterminada, polo que
                                  //executando-o, n importa desactivar esta instru.

#local Estudo=false;  //Para criar a anima final, realista, faga-se Estudo=false.
#local Acompanhamento=false;  //Mensagens sobre que partes da buxaina roam no cho e se a ponta est ou
                                                                                       //n amarrada.

#local FrequenciaDeCalculo=50000;  //Nmero de instantes por segundo nos que se calcularm as foras.
#local MassaDoCorpo=.1;
#local MassaDaPonta=0;
#local MassaDoCuruto=0;
#local InclinacoInicial=-.1;
#local VelocAngInicial=500;
#local AmortecimentoGeral=1e-3;
#local RigidezDoChao=5000;
#local RigidezDaCola=5000;
#local AmortecimentoDoChao=5;
#local RocamentoDoCorpo=.7;
#local RocamentoDaPonta=10;
#local Alturadacola=.002;
#local SobremedidaDoChao=.001;


//------------------------------------------- Cena --------------------------------------------------------

#include "Matematica.inc"
#include "Mecanica.inc"

global_settings{
  assumed_gamma 1
  max_trace_level 25
}

#if(Estudo)
  background{rgb<.01,0,.05>}
#else
  background{rgb<.08, .58, .72>}
#end

light_source{1e7*y rgb 1 rotate<-70,30,0>}

//Cho
plane{y,0
  #if(Estudo)
    pigment{hexagon rgbft<1,0,0,.5,.3>, rgbft<0,1,0,.5,.3>, rgbft<0,0,1,.5,.3>}
  #else
    texture{
      pigment{granite scale .1}
      normal{granite .2 scale .1}
      finish{diffuse .8 brilliance .8 specular .7 roughness .1}
    }
  #end
}
union{  //A buxaina
  cylinder{.09*y, .115*y, .0075}  //Mango
  sphere_sweep{
    cubic_spline
    6,
    .075*y, .035
    .065*y, .035,
    .03*y, .014,
    .01*y, .004,
    0, 0,
    -.01*y, -.003
    //tolerance 0.001
  }
  #if(Estudo)
    pigment{
      radial colour_map{
        [0 rgbt<1,0,0,.5>]
        [1/6 rgbt<1,1,0,.5>]
        [2/6 rgbt<0,1,0,.5>]
        [3/6 rgbt<0,1,1,.5>]
        [4/6 rgbt<0,0,1,.5>]
        [5/6 rgbt<1,0,1,.5>]
        [1 rgbt<1,0,0,.5>]
      }
    }
  #else
    cone{-.0001*y, .0025, .01*y, .0045 
      texture{
        pigment{rgb<.8,.6,.3>}
        normal{wrinkles scale .001}
        finish{diffuse .8 brilliance 4 specular .8 roughness .005}
      }
    }
    texture{
      pigment{wood warp{turbulence .3} scale .001 rotate -80*x}
      normal{bumps .2 scale .001}
      finish{diffuse .7 specular .4 roughness .1}
    }
  #end
  rotate degrees(InclinacoInicial)*z
  #local Posys=array[3]{
    .065*<-sin(InclinacoInicial),cos(InclinacoInicial),0>, <0,0,0>,
    .115*<-sin(InclinacoInicial),cos(InclinacoInicial),0>
  }
  #local Inys=array[3][7]{
    {0, 0, 0, 0, 0, 0, 0}
    {MassaDaPonta, 0, 0, 0, 0, 0, 0}
    {MassaDoCuruto, 0, 0, 0, 0, 0, 0}
  }
  InerciaEsfera(MassaDoCorpo, .035, Inys, 0)
  //#local MecXos_MassasAgentes=array[3][1]{{0} {0} {0}}
  //#local MecXos_VectsAgentes=array[3][1]{{<0,0,0>}{<0,0,0>}{<0,0,0>}}
  #if(clock=0)
    #declare PontoDeAmarre=<0,0,0>;
  #else
    #if(strlen(Xose_PastaTemp)=0)
      #fopen Xailo "Amarre da buxaina II.xose" read
    #else
      #fopen Xailo concat(Xose_PastaTemp,"\\Amarre da buxaina II.xose") read
    #end
    #read(Xailo, PontoDeAmarre)
    #fclose Xailo
  #end
  #macro MecXos_Forcas(ICorpo, IElmt, Resultante, Momento)
    #switch(IElmt)
    #case(0)  //Corpo
      #declare Momento=-AmortecimentoGeral*pow(.035,2)*MecXos_VelocidadesAngulares[ICorpo];
      #if(Posico.y<.035+SobremedidaDoChao)
        #if(vlength(<MecXos_Velocidades[ICorpo].x,0,MecXos_Velocidades[ICorpo].z>+vcross(Posico.y*y,MecXos_VelocidadesAngulares[ICorpo]))=0)
          #local Tchuf=<0,0,0>;
        #else
          #local Tchuf =
            RocamentoDoCorpo*vnormalize(<MecXos_Velocidades[ICorpo].x,0,MecXos_Velocidades[ICorpo].z>+vcross(Posico.y*y,MecXos_VelocidadesAngulares[ICorpo]));
        #end
        #local Nhariz=RigidezDoChao*(.035+SobremedidaDoChao-Posico.y)*(y-Tchuf) -
          AmortecimentoDoChao*MecXos_Velocidades[ICorpo].y*y;
        #declare Momento=Momento+vcross(Nhariz,Posico.y*y);
        #if(Acompanhamento)
          #debug "O corpo si roca. "
        #end
      #else
        #local Nhariz=<0,0,0>;
        #if(Acompanhamento)
          #debug "O corpo non roca."
        #end
      #end
    #break
    #case(1)  //Ponta
      #if(Posico.y<Alturadacola)
        #if(PontoDeAmarre.y=0)
          #declare PontoDeAmarre=<Posico.x,1,Posico.z>;
          #local Cacca=<0,0,0>;
        #else
          #local Cacca=RigidezDaCola*(PontoDeAmarre-Posico);
          #local Cacca=<Cacca.x,0,Cacca.z>;
        #end
      #else
        #local Cacca=<0,0,0>;
        #declare PontoDeAmarre=<0,0,0>;
      #end
      #if(Posico.y<SobremedidaDoChao)
        #if(vlength(<MecXos_Velocidades[ICorpo].x,0,MecXos_Velocidades[ICorpo].z>)=0)
          #local Tchuf=<0,0,0>;
        #else
          #local Tchuf=RocamentoDaPonta*vnormalize(<MecXos_Velocidades[ICorpo].x,0,MecXos_Velocidades[ICorpo].z>);
        #end
        #local Nhariz=RigidezDoChao*(SobremedidaDoChao-Posico.y)*(y-Tchuf) -
          AmortecimentoDoChao*Velocidade.y*y+Cacca;
        #if(Acompanhamento)
          #debug " A ponta sim roca. "
        #end
      #else
        #local Nhariz=Cacca;
        #if(Acompanhamento)
          #debug " A ponta no roca."
        #end
      #end
      #if(Acompanhamento)
        #if(PontoDeAmarre.y=0)
          #debug " Sem amarre.                                                       "
        #else
          #debug concat(" Ponto de amarre = (", str(PontoDeAmarre.x,0,17), ", 0, ",
            str(PontoDeAmarre.z,0,17), ")  ")
        #end
      #end
    #break
    #case(2)  //Curuto
      #if(Posico.y<SobremedidaDoChao)
        #if(vlength(<Velocidade.x,0,Velocidade.z>)=0)
          #local Tchuf=<0,0,0>;
        #else
          #local Tchuf=RocamentoDoCorpo*vnormalize(<Velocidade.x,0,Velocidade.z>);
        #end
        #local Nhariz=RigidezDoChao*(SobremedidaDoChao-Posico.y)*(y-Tchuf) -
          AmortecimentoDoChao*Velocidade.y*y;
        #if(Acompanhamento)
          #debug "O curuto sim roca.\n"
        #end
      #else
        #local Nhariz=<0,0,0>;
        #if(Acompanhamento)
          #debug "O curuto no roca.\n"
        #end
      #end
    #end
    #declare Resultante=Massa*Gravidade-AmortecimentoGeral*Velocidade+Nhariz;
  #end
  MovSolRigCampoDeForcas("Frango com nata", Posys, Inys, <0,0,0>,
    VelocAngInicial*<-sin(InclinacoInicial),cos(InclinacoInicial),0>, clock,
    FrequenciaDeCalculo*clock_delta)
  #if(strlen(Xose_PastaTemp)=0)
    #fopen Xailo "Amarre da buxaina II.xose" write
  #else
    #fopen Xailo concat(Xose_PastaTemp,"\\Amarre da buxaina II.xose") write
  #end
  #write(Xailo, "<", vstr(3,PontoDeAmarre,",",0,17), ">")
  #fclose Xailo
  transform Movimento
  #if(Acompanhamento)
    #debug concat("  Rapidez angular = ", str(vlength(MecXos_Omega)*30/pi,0,4), " rpm")
  #end
}

#if(Estudo)
  sphere{MecXos_CM, .01 pigment{rgb<0,1,0>}}
  sphere{0, .005 pigment{rgb<0,1,1>} transform Movimento}
  cylinder{-1e7*x, 1e7*x, .003 pigment{rgb 0}}
  cylinder{-1e7*y, 1e7*y, .003 pigment{rgb 0}}
  cylinder{-1e7*z, 1e7*z, .003 pigment{rgb 0}}
#end

camera{
  #local Ali=<MecXos_CM.x,0,MecXos_CM.z>;
  location Ali+<-.1, min(1.6, max(.1, MecXos_CM.y)), -.5>
  right 4/3*x
  up y
  direction 3*z
  look_at Ali+max(.05, MecXos_CM.y-.02)*y
}