// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Buxaina.pov
// Vers: 3.5
// Descri: Umha buxaina bailando.
// Data: 5-XII-2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

#include "Matematica.inc"
#include "Mecanica.inc"

global_settings{
  assumed_gamma 1
  max_trace_level 25
}

background{rgb<.01,0,.05>}

light_source{<-30,20,-30> rgb 1}

plane{y,0 pigment{hexagon rgbft<1,0,0,.5,.3>, rgbft<0,1,0,.5,.3>, rgbft<0,0,1,.5,.3>}}

#local FrequenciaDeCalculo=5000;  //Nmero de instantes por segundo nos que se calcularm as foras.
#local InclinacoInicial=-pi/6;
#local VelocAngInicial=0;
#local MassaTot=.1;
#local AmortecimentoGeral=.1;
#local RigidezDaLigadura=10000;
#local AmortecimentoDaLigadura=5;
union{
  cylinder{.09*y, .115*y, .0075}
  sphere_sweep{
    cubic_spline
    6,
    .075*y, .035
    .065*y, .035,
    .03*y, .01,
    .01*y, .003,
    0, 0,
    -.01*y, -.003
    //tolerance 0.001
  }
  rotate degrees(InclinacoInicial)*z
  pigment{rgbt<1,0,0,.5>}
  #local Posys=array[2]{<-.065*sin(InclinacoInicial),.065*cos(InclinacoInicial),0>, 0*<-sin(InclinacoInicial),cos(InclinacoInicial),0>}
  #local Inys=array[1][7]{{0,0,0,0,0,0,0}}
  InerciaEsfera(MassaTot, .035, Inys, 0)
//  #local MA=array[2][1]{{0}{0}}
//  #local VA=array[2][1]{{<0,0,0>}{<0,0,0>}}
  #macro MecXos_Forcas(Indice, Posico, Velocidade, VelAng, Tempo, Massa, MassasAgentes, VectsAgentes,
    For, Mom)
    #declare For=Massa*Gravidade-AmortecimentoGeral*Velocidade /*-
      ((Indice=1)? RigidezDaLigadura*Posico+AmortecimentoDaLigadura*Velocidade: 0)*/;
      //0;
  #end
  MovSolRigCampoDeForcas("A las pantas del pipano", Posys, Inys, <0,0,0>,
    VelocAngInicial*<-sin(InclinacoInicial),cos(InclinacoInicial),0>,
    //VelocAngInicial,
    //<0,0,10000>,
    clock, FrequenciaDeCalculo*clock_delta)
  transform Movimento
}

sphere{MecXos_CM, .01 pigment{rgb<0,1,0>}}
sphere{0, .005 pigment{rgb<0,1,1>} transform Movimento}
cylinder{-1e7*x, 1e7*x, .003 pigment{rgb 0}}
cylinder{-1e7*y, 1e7*y, .003 pigment{rgb 0}}
cylinder{-1e7*z, 1e7*z, .003 pigment{rgb 0}}
camera{
  location <-.1,.1,-.5>
  right 4/3*x
  up y
  direction 3*z
  look_at MecXos_CM
}