// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Camara.inc
// Vers: 3.5
// Descri: Ajuda a controlar a cmara
// Data de cria: 4-VI-2003; procede do velho Utiles de Xose.inc, criado o 16-IV-2002.
// Data da ltima actualiza: _
// Autor: Xos B. Carballeira Rabual


#local versionDatiles=version;
#version 3.5;

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Camara.inc\", que ajuda a controlar a camara.\n"
#end

#ifndef(Xose_SRDextrogiro)  //Se esta varivel n vale 0, os observadores definidos neste arquivo
  #declare Xose_SRDextrogiro=false;   //verm dextrgiro o sistema de referncia. Lembremos que os
#end                                  //caracteres dextrgiro-levgiro s relativos.


//======================================== CMARAS COM LUZ ===================================================

#macro SouMineiro(Aqui, MirandoParaAli, AlturaDaLuz, AlcanceDaLuz)
  camera{
    location Aqui
    right<4/3,0,0>
    up(Xose_SRDextrogiro? <0,0,1>: <0,1,0>)
    direction(Xose_SRDextrogiro? <0,3,0>: <0,0,3>)
    #if(Xose_SRDextrogiro)
      sky<0,0,1>
    #end
    look_at MirandoParaAli
  }
  light_source{
    Aqui+AlturaDaLuz*(Xose_SRDextrogiro? z: y)
    color rgb 1
    fade_distance AlcanceDaLuz
    fade_power 2
    media_attenuation on
  }
#end

#macro SouPeixeMineiro(Aqui, MirandoParaAli, AlturaDaLuz, AlcanceDaLuz)
  camera{
    fisheye
    location Aqui
    right<1,0,0>
    up(Xose_SRDextrogiro? <0,0,1>: <0,1,0>)
    direction(Xose_SRDextrogiro? <0,3,0>: <0,0,3>)
    #if(Xose_SRDextrogiro)
      sky<0,0,1>
    #end
    look_at MirandoParaAli
    angle 180
  }
  light_source{
    Aqui+AlturaDaLuz*(Xose_SRDextrogiro? z: y)
    color rgb 1
    fade_distance AlcanceDaLuz
    fade_power 2
    media_attenuation on
  }
#end


#version versionDatiles;