// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Conversor de imagens.pov
// Vers: 3.6
// Descri: Cena conversora de imagens
// Data de cria: 24-V-2003
// Data da ltima actualiza: 27-VIII-2004
// Autor: Xos B. Carballeira Rabual

#version 3.6;

// Este arquivo h-se de executar atravs do Conversor de imagens.ini.

//--------------------------------------------- OPES ----------------------------------------------------

// Estabelea-se o resto das opes no arquivo Conversor de imagens.ini

// Nome do arquivo original, sem a extens, ou parte comum dos nomes dos quadros se se tratar duma anima:
#declare NomeOrigem="Capa"

// Recorte da imagem original. As seguintes variveis descrevem o rectngulo recortado em propor s di-
//menses originais da imagem; para a converter inteira, igualem-se as duas primeiras variveis a 0 e as
//outras duas a 1.
#declare ColInicial  = 0;
#declare FilaInicial = 0;
#declare ColFinal    = 1;
#declare FilaFinal   = 1;

#declare QuantosOlhos=1;  // Quando se empregar um valor maior que 1, juntar-se-am os quadros consecutivos
                                                                   //para obter imagens estereoscpicas.

// Formato original:
//#declare FormatoOrigem=0; //GIF
//#declare FormatoOrigem=1; //Targa
//#declare FormatoOrigem=2; //IFF
//#declare FormatoOrigem=3; //PPM
//#declare FormatoOrigem=4; //PGM
//#declare FormatoOrigem=5; //PNG
//#declare FormatoOrigem=6; //JPEG
//#declare FormatoOrigem=7; //TIFF
#declare FormatoOrigem=8; //BMP; s funciona no POV-Ray para o Windows

// Interpola entre os pxeis originais ao criar a imagem destino; aconselha-se quando a resolu ori-
//ginal e final forem distintas:
//#declare Interpolaco=0; //Nenguma
#declare Interpolaco=2; //Bilinear
//#declare Interpolaco=4; //Segundo a distncia normalizada

//background{rgb 0}  //Cor de fundo; entrever-se- se a imagem original tiver alguma transparncia e n se
                     //decidiu conserv-la (v. Conversor de imagens.ini).

// Correc do gamma:
//global_settings{assumed_gamma 1}  // Active-se ao converter entre os formatos seguintes:
                                       //  do PNG para o BMP,
                                       //  do PNG para o PNG, e
                                       //  do PNG para o Targa;
                                  // desactive-se para converter:
                                       //  do BMP para o PNG,
                                       //  do BMP para o BMP,
                                       //  do Targa para o Targa, e
                                       //  do JPEG para o PNG.
                                  // Ainda n sei se convm nos restantes casos.


//--------------------------------------------- CENA -----------------------------------------------------

camera{
  orthographic
  location <.5,.5,-1>
  right x
  up y
  direction z
}

#switch(FormatoOrigem)
  #case(0)
    #declare Extenso="gif"
  #break
  #case(1)
    #declare Extenso="tga"
  #break
  #case(2)
    #declare Extenso="iff"
  #break
  #case(3)
    #declare Extenso="ppm"
  #break
  #case(4)
    #declare Extenso="pgm"
  #break
  #case(5)
    #declare Extenso="png"
  #break
  #case(6)
    #declare Extenso="jpg"
  #break
  #case(7)
    #declare Extenso="tif"
  #break
  #case(8)
    #declare Extenso="bmp" //Quando eu conhecer a extens dos formatos caractersticos doutros siste-
  #break                             //mas, como o Pict do Mac, engadi-los-ei.
#end

#declare Imagens=array[QuantosOlhos]

#declare ContaOlhos=0;
#while(ContaOlhos<QuantosOlhos)
  #declare Imagens[ContaOlhos]=pigment{
    image_map{
      #switch(FormatoOrigem)
        #case(0)
          gif
        #break
        #case(1)
          tga
        #break
        #case(2)
          iff
        #break
        #case(3)
          ppm
        #break
        #case(4)
          pgm
        #break
        #case(5)
          png
        #break
        #case(6)
          jpeg
        #break
        #case(7)
          tiff
        #break
        #case(8)  // Quando eu conhecer a extens dos formatos caractersticos doutros sistemas,
          sys              //como o Pict do Mac, engadi-los-ei.
        #break
      #end
      #if(clock_on)
        concat(NomeOrigem,str(QuantosOlhos*(frame_number-1)+ContaOlhos+1,-floor(log(QuantosOlhos*final_frame))-1,0),".",Extenso)
      #else
        #if(QuantosOlhos>1)
          concat(NomeOrigem,str(ContaOlhos+1,-floor(log(QuantosOlhos))-1,0),".",Extenso)
        #else
          concat(NomeOrigem,".",Extenso)
        #end
      #end
      once interpolate Interpolaco
    }
    translate<-ColInicial,-1+FilaFinal,0> scale<1/(ColFinal-ColInicial),1/(FilaFinal-FilaInicial),1>
    translate ContaOlhos*x scale <1/QuantosOlhos,1,1>
  }
  #declare ContaOlhos=ContaOlhos+1;
#end

plane{-z, 0
  pigment{
    #if(QuantosOlhos>1)
      gradient x pigment_map{
        #declare ContaOlhos=0;
        #while(ContaOlhos<QuantosOlhos)
          #if (ContaOlhos!=0) [ContaOlhos/QuantosOlhos Imagens[ContaOlhos]] #end
          #if (ContaOlhos!=QuantosOlhos-1) [(ContaOlhos+1)/QuantosOlhos Imagens[ContaOlhos]] #end
          #declare ContaOlhos=ContaOlhos+1;
        #end
      }
    #else
      Imagens[0]
    #end
  }
  finish{diffuse 0 ambient 1}
}