// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Croft em relevo.pov
// Vers: 3.5
// Descri: Cena patr para fazer imagens em escala de grisses, nas que a luminosidade representa a
  //dimens perpendicular ao quadro.
// Data: 31-X-2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

global_settings{
  hf_gray_16  //Para criar imagens de 2^16 grisses, quando o tipo de arquivo de sada  ajeitado
}


//================================= DEFINI DA CMERA ==================================================

//#declare Xose_SRDextrogiro=true;  //Quando o sistema de referncia seja dextrgiro, active-se isto
                                  //para indic-lo.

#declare Relevo_TipoDeCamera=0;   //Projec cnica (perspectiva), a predeterminada
//#declare Relevo_TipoDeCamera=1;   //Projec ortogonal
//#declare Relevo_TipoDeCamera=2;   //Olho de peixe (esfrica polar)
//#declare Relevo_TipoDeCamera=3;   //Gram angular
//#declare Relevo_TipoDeCamera=4;   //Omnimax
//#declare Relevo_TipoDeCamera=5;   //Panormica
//#declare Relevo_TipoDeCamera=6;   //Cilindro vertical, ponto de vista fixo
//#declare Relevo_TipoDeCamera=7;   //Cilindro horizontal, ponto de vista fixo
//#declare Relevo_TipoDeCamera=8;   //Cilindro vertical, ponto de vista mvel
//#declare Relevo_TipoDeCamera=9;   //Cilindro horizontal, ponto de vista mvel
//#declare Relevo_TipoDeCamera=10;  //Esfrica cartesiana

#declare Relevo_UbiCamera=<0,1,-2.5>; //<0, 1.5, -3>;  //Ubicacin da cmara
#declare Relevo_Largo=4/3*x;   //Vector que vai horizontalmente do extremo esquerdo ao dereito do quadro,
                                    //antes de girar a cmera
//#declare Relevo_Alto=y/3;      //Vector que vai verticalmente do extremo inferior ao superior do quadro,
                                    //antes de girar a cmera
#declare Relevo_Focal=1.5*z;       //Vector que vai do ponto de vista ao centro do quadro, antes de girar a
                                    //cmera
//#declare Relevo_CeuCamera=y;   //Vector arredor do que gira a cmera para apontar ao motivo; ficar sem-
                                    //pre cara arriba na imagem
//#declare Relevo_AngCamera=25;  //ngulo da cmera
//#declare Relevo_AngCamera2=<180,90>;  //ngulos horizontal e vertical da cmera esfrica cartesiana
#declare Relevo_OlhaCara=<-.2,.2,0>;//<-.25, 0, 0>;  //Motivo, ponto que quedar no centro da imagem

#declare Relevo_ExponentePerto=1.8;//.3;
#declare Relevo_ExponenteLonge=13;//2;
#declare Relevo_FactorPerto=1.02;//3;
#declare Relevo_FactorLonge=.95;//1;

#include "Relevo.inc"


//======================================== OBJECTOS DA CENA =================================================

//Os objectos devem ter a textura Relevo_Tex, ou bem carecer de textura.

plane {y,0}

#include "bmpeople.inc"
#include "bm_pose.inc"
#include "croft.cdf"

//#declare BM_HairStyle=0; //Sem plo; agiliza as provas.

#declare BM_PoseNo=11;
#declare BM_EyeLids=<.35,0,.35>;
#declare BM_Jaw=.25;
#declare BM_Mouth=1;
#declare BM_MouthShape=1;

Blob_Man(Female,2)
object {BlobMan 
        transform BMO_Abdomen_L
        rotate z*-85
}