// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Data e hora.inc
// Vers: 3.6
// Descri: Ajuda a trabalhar com datas e horas.
// Data de cria: 22-IX-2004
// Data da ltima actualiza: _
// Autor: Xos B. Carballeira Rabual


#local versDataHora=version;
#version 3.6;

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Data e hora.inc\", que ajuda a trabalhar com datas e horas.\n"
#end

//Requer:
//#include /*...?*/             //Precisa este arquivo auxiliar que algum outro se execute antes?
//...?                                                                      //Convm anot-lo aqui.

#macro Bissesto(Ano)  //  ou n bissesto o ano introduzido?
  (((mod(Ano,4)=0)&(mod(Ano,100)!=0))|(mod(Ano,400)=0))
#end

#macro DiaDaSemana(Dia,Mes,Ano)  // Dia da semana: 0 = segunda-feira, 1 = tera, ..., 6 = domingo
  #local AcumMes=array[12]{0 3 3 6 1 4 6 2 5 0 3 5}
  #local Seculo=int(Ano/100);
  #local lAno=mod(Ano,100);
  mod(
    5*Seculo+int(Seculo/4) +
      lAno+int(lAno/4) +
      AcumMes[Mes-1]-((Bissesto(Ano)&(Mes<3))? 1: 0)+Dia +
      5
    , 7
  )
#end

#macro DiaDaSemanaComLetras(DiaDaSemanaComNumero,ApenasCaracteresASCII)
  #switch(DiaDaSemanaComNumero)
    #case(0)
      #declare Feira="segunda-feira"
    #break
    #case(1)
      #if(ApenasCaracteresASCII)
        #declare Feira="terca-feira"
      #else
        #declare Feira="tera-feira"
      #end
    #break
    #case(2)
      #declare Feira="quarta-feira"
    #break
    #case(3)
      #declare Feira="quinta-feira"
    #break
    #case(4)
      #declare Feira="sexta-feira"
    #break
    #case(5)
      #if(ApenasCaracteresASCII)
        #declare Feira="sabado"
      #else
        #declare Feira="sbado"
      #end
    #break
    #case(6)
      #declare Feira="domingo"
    #break
  #else
    #error "No vale este dia da semana!"
  #end
#end


#version versDataHora;