// Arquivo principal de cena para o traador de raios de Persistence of Vision
// Arquivo: Daus fenaus.pov
// Vers: 3.6
// Descri: Uns dados a rolar
// Data de cria: 14-IX-2004
// Data da ltima actualiza: 19-IX-2004
// Autor: Xos B. Carballeira Rabual


// Para 4 de simula (20 imagens por segundo):
//+w200 +h200 +a0.3 -j +kff9600
//+w240 +h240 +a0.3 -j +kff9600


#version 3.6;

//============================================= OPES ===================================================

#declare Freq=5e3;//1e4;
#declare TempoTotal=6;

#declare QuantosDados=3;

#declare Massas=array[QuantosDados]{.125,.125,.125}
#declare Arestas=array[QuantosDados]{.05*<1,1,1>,.05*<1,1,1>,.05*<1,1,1>}
#declare RaiosRedond=array[QuantosDados]{.005,.005,.005}
#declare EixPontos=array[QuantosDados]{<.004,.003>,<.004,.003>,<.004,.003>}  // <Tangencial, Normal>

#declare CorPontos=array[QuantosDados]{rgb<1,.2,0>, rgb<0,1,.2>, rgb<.2,0,1>}
#declare CorCorpo=array[QuantosDados]{rgbf<.5,.9,1,0>, rgbf<1,.5,.9,0>, rgbf<.9,1,.5,0>}

#declare Brilhante=finish{diffuse .5 brilliance 2 specular .8 roughness 1/50}
#declare Mate=finish{diffuse .7 specular .5 roughness 1/10}
#declare Fin_Vidro=finish{
  diffuse 0 ambient 0 specular .5 roughness 1/50 reflection{fresnel} conserve_energy
}
#declare Fin_Ceramica=finish{
  diffuse .7 specular .3 roughness 1/20 reflection{fresnel} conserve_energy
}
#declare FinishPontos=array[QuantosDados]{Brilhante,Brilhante,Brilhante}
#declare FinishCorpo=array[QuantosDados]{Fin_Ceramica,Fin_Ceramica,Fin_Ceramica}
#declare Int_Vidro=interior{
  ior 1.5
  dispersion 1.01
}
#declare Interior=array[QuantosDados]{Int_Vidro,Int_Vidro,Int_Vidro}


#declare PosIniciais=array[QuantosDados]{<-.1,.15,0>,<0,.15,0>,<.1,.15,0>}
#declare RotIniciais=array[QuantosDados]{
  transform{rotate<1,60,0>}, transform{rotate<1,60,0>},
  transform{rotate<1,60,0>}
}
// De ponta
/*#declare RotIniciais=array[QuantosDados]{
  transform{rotate<45,0,degrees(atan(1/sqrt(2)))>}, transform{rotate<45,0,degrees(atan(1/sqrt(2)))>},
  transform{rotate<45,0,degrees(atan(1/sqrt(2)))>}
}*/
#declare VelIniciais=array[QuantosDados]{<0,0,0>,<0,0,0>,<0,0,0>}
#declare VelAngIniciais=array[QuantosDados]{<0,0,0>,<0,0,0>,<0,0,0>}

#declare Gravidade=-9.8*y;

#declare RigChaoDado=5e3;
#declare AmortChaoDadoN=.3;

#declare AmortChaoDadoT=0;
#declare CoefAtritoChaoDado=.5;
#declare CoefRodaduraChaoDado=.0001;
#declare CoefPivotamentoChaoDado=.0001;

#declare RigDados=5e3;
#declare AmortDadosN=.3;

#declare AmortDadosT=0;
#declare CoefAtritoDados=.5;
#declare CoefRodaduraDados=.0001;
#declare CoefPivotamentoDados=.0001;

#declare AltCamara=.2;
#declare FactAfastCamara=2;
#declare DesvHCamara=0;
#declare MaxAtrasoCamara=.025;
#declare MaxAtrasoMotivo=.01;


#declare Disperso=off;
#declare LuzExtensa=on;
#declare Fotons=off;
#declare RecolheFotonsCorpo=array[QuantosDados]{off, off, off}


//============================================== CENA ====================================================

#declare ContaDados=0;
#declare MaxAresta=0;
#while(ContaDados<QuantosDados)
  #if(MaxAresta<Arestas[ContaDados].x)
    #declare MaxAresta=Arestas[ContaDados].x;
  #end
  #if(MaxAresta<Arestas[ContaDados].y)
    #declare MaxAresta=Arestas[ContaDados].y;
  #end
  #if(MaxAresta<Arestas[ContaDados].z)
    #declare MaxAresta=Arestas[ContaDados].z;
  #end
  #declare ContaDados=ContaDados+1;
#end

global_settings{
  assumed_gamma 1
  ambient_light 1.6
  max_trace_level 40
  #if(Fotons)
    photons{
      spacing MaxAresta/300                 // specify the density of photons
      //count 100000               // alternatively use a total number of photons
  
      gather 20, 100            // amount of photons gathered during render [20, 100]
      //media max_steps [,factor]  // media photons
      //jitter 1.0                 // jitter phor photon rays
      //max_trace_level 5          // optional separate max_trace_level
      //adc_bailout 1/255          // see global adc_bailout
      //save_file "filename"       // save photons to file
      //load_file "filename"       // load photons from file
      //autostop 0                 // photon autostop option
      radius MaxAresta/300                  // manually specified search radius
      // (---Adaptive Search Radius---)
      //steps 1
      expand_thresholds .2, 40
    }
  #end
}

#if(mod(frame_number,2)=1)
  #declare Tempo=TempoTotal*clock;
#else
  #declare Tempo=TempoTotal*(clock-clock_delta);
#end

#declare Inzinhas=array[QuantosDados][9][7]

//#include "colors.inc"
//#include "metals.inc"
//#include "stones1.inc"
//#include "stones2.inc"
#include "Matematica.inc"
#include "Mecanica.inc"

#declare Nos=array[QuantosDados]
#declare Poss=array[QuantosDados][9]

#declare ContaDados=0;
#while(ContaDados<QuantosDados)
  #declare ArestaX=Arestas[ContaDados].x;
  #declare ArestaY=Arestas[ContaDados].y;
  #declare ArestaZ=Arestas[ContaDados].z;
  InerciaCaixa(
    Massas[ContaDados], Arestas[ContaDados].x, Arestas[ContaDados].y, Arestas[ContaDados].z,
    Inzinhas, ContaDados, 0
  )
  InerciaRot(Inzinhas, ContaDados, 0, transform{RotIniciais[ContaDados]})
  InerciaNulo(Inzinhas,ContaDados,1)
  InerciaNulo(Inzinhas,ContaDados,2)
  InerciaNulo(Inzinhas,ContaDados,3)
  InerciaNulo(Inzinhas,ContaDados,4)
  InerciaNulo(Inzinhas,ContaDados,5)
  InerciaNulo(Inzinhas,ContaDados,6)
  InerciaNulo(Inzinhas,ContaDados,7)
  InerciaNulo(Inzinhas,ContaDados,8)
  #declare Nos[ContaDados]=9;
  #declare Poss[ContaDados][0]=PosIniciais[ContaDados];
  #declare RotaMe=function{transform{RotIniciais[ContaDados]}}
  #declare Poss[ContaDados][1]=PosIniciais[ContaDados] +
    RotaMe(ArestaX/2,ArestaY/2,ArestaZ/2)
  ;
  #declare Poss[ContaDados][2]=PosIniciais[ContaDados] +
    RotaMe(ArestaX/2,ArestaY/2,-ArestaZ/2)
  ;
  #declare Poss[ContaDados][3]=PosIniciais[ContaDados] +
    RotaMe(ArestaX/2,-ArestaY/2,ArestaZ/2)
  ;
  #declare Poss[ContaDados][4]=PosIniciais[ContaDados] +
    RotaMe(ArestaX/2,-ArestaY/2,-ArestaZ/2)
  ;
  #declare Poss[ContaDados][5]=PosIniciais[ContaDados] +
    RotaMe(-ArestaX/2,ArestaY/2,ArestaZ/2)
  ;
  #declare Poss[ContaDados][6]=PosIniciais[ContaDados] +
    RotaMe(-ArestaX/2,ArestaY/2,-ArestaZ/2)
  ;
  #declare Poss[ContaDados][7]=PosIniciais[ContaDados] +
    RotaMe(-ArestaX/2,-ArestaY/2,ArestaZ/2)
  ;
  #declare Poss[ContaDados][8]=PosIniciais[ContaDados] +
    RotaMe(-ArestaX/2,-ArestaY/2,-ArestaZ/2)
  ;
  #undef RotaMe
  #declare ContaDados=ContaDados+1;
#end

#macro MecXos_Forcas(CorpoActual, ElementoActual, Resultante, Momento)
  #switch(ElementoActual)
    #case(0)  //Corpo
      #local Rotada=function{transform{RotIniciais[CorpoActual] MecXos_Rotacoes[CorpoActual]}}
      #declare Resultante=Massas[CorpoActual]*Gravidade;
      #declare Momento=0;
      #local EsteSouEu=box{
        1/2, -1/2 scale Arestas[CorpoActual]
        transform{RotIniciais[CorpoActual]} transform{MecXos_Rotacoes[CorpoActual]} translate MecXos_CMs[CorpoActual]
      }
      #local ContaDaus=0;
      #while(ContaDaus<QuantosDados)
        #if(ContaDaus!=CorpoActual)
          #local ContaPontas=1;
          #while(ContaPontas<9)
            #if(inside(EsteSouEu,MecXos_Posicoes[ContaDaus][ContaPontas]))
              #local Chouff=MecXos_Posicoes[ContaDaus][ContaPontas]-MecXos_CMs[CorpoActual];
              #local Penetr = Arestas[CorpoActual]/2 -
                <abs(vdot(Chouff,Rotada(1,0,0))), abs(vdot(Chouff,Rotada(0,1,0))), abs(vdot(Chouff,Rotada(0,0,1)))>
              ;
              #local Penetreixon=min(Penetr.x,Penetr.y,Penetr.z);
              #switch(Penetreixon)
                #case(Penetr.x)
                  #local Chant=-Penetreixon*vdot(Chouff,Rotada(1,0,0))/abs(vdot(Chouff,Rotada(1,0,0)))*Rotada(1,0,0);
                #break
                #case(Penetr.y)
                  #local Chant=-Penetreixon*vdot(Chouff,Rotada(0,1,0))/abs(vdot(Chouff,Rotada(0,1,0)))*Rotada(0,1,0);
                #break
                #case(Penetr.z)
                  #local Chant=-Penetreixon*vdot(Chouff,Rotada(0,0,1))/abs(vdot(Chouff,Rotada(0,0,1)))*Rotada(0,0,1);
                #break
              #else
                #error "Semelha haver um erro de calculo."
              #end
              #local VelRel=MecXos_Velocidades[ContaDaus][ContaPontas]-MecXos_VelocidadesCM[CorpoActual]-vcross(MecXos_VelocidadesAngulares[CorpoActual],Chouff);
              #local Transvers=vdot(VelRel,vnormalize(Chant))*vnormalize(Chant);
              #local Escorreg=VelRel-Transvers;
              #if(vlength(Escorreg)=0)
                #local DirEsvar=<0,0,0>;
              #else
                #local DirEsvar=vnormalize(Escorreg);
              #end
              #local Reacc = RigDados*vlength(Chant)* ( vnormalize(Chant) +
                CoefAtritoDados*DirEsvar ) +
                AmortDadosN*Transvers +
                AmortDadosT*Escorreg
              ;
              #declare Resultante=Resultante+Reacc;
              #local Rod=MecXos_VelocidadesAngulares[ContaDaus]-MecXos_VelocidadesAngulares[CorpoActual];
              #local Piv=vdot(Rod,vnormalize(Chant))*vnormalize(Chant);
              #declare Rod=Rod-Piv;
              #declare Momento=Momento+vcross(Chouff,Reacc)+CoefRodaduraDados*Rod+CoefPivotamentoDados*Piv;
            #end
            #declare ContaPontas=ContaPontas+1;
          #end
        #end
        #declare ContaDaus=ContaDaus+1;
      #end
      #undef Rotada
    #break
  #else  //Cantos
    #local OndeEstou=MecXos_Posicoes[CorpoActual][ElementoActual];
    #if(OndeEstou.y<=0)
      #local Vel=MecXos_Velocidades[CorpoActual][ElementoActual];
      #local VelH=Vel-Vel.y*y;
      #if(vlength(VelH)=0)
        #local CaraOndeH=<0,0,0>;
      #else
        #local CaraOndeH=vnormalize(VelH);
      #end
      #declare Resultante =
        - RigChaoDado*OndeEstou.y*(y-CoefAtritoChaoDado*CaraOndeH)
        - AmortChaoDadoN*Vel.y*y - AmortChaoDadoT*VelH
      ;
      #local Oumeigha=MecXos_VelocidadesAngulares[CorpoActual];
      #local OumRod=Oumeigha-Oumeigha.y*y;
      #declare Momento=-CoefRodaduraChaoDado*OumRod-CoefPivotamentoChaoDado*Oumeigha.y*y;
    #else
      #declare Resultante=0;
      #declare Momento=0;
    #end
    #local ContaDaus=0;
    #while(ContaDaus<QuantosDados)
      #if(ContaDaus!=CorpoActual)
        #local EsteEsTu=box{
          1/2, -1/2 scale Arestas[ContaDaus]
          transform{RotIniciais[ContaDaus]} transform{MecXos_Rotacoes[ContaDaus]} translate MecXos_CMs[ContaDaus]
        }
        #if(inside(EsteEsTu,MecXos_Posicoes[CorpoActual][ElementoActual]))
          #local Chouff=MecXos_Posicoes[CorpoActual][ElementoActual]-MecXos_CMs[ContaDaus];
          #local Rotada=function{transform{RotIniciais[ContaDaus] MecXos_Rotacoes[ContaDaus]}}
          #local Penetr = Arestas[ContaDaus]/2 -
            <abs(vdot(Chouff,Rotada(1,0,0))), abs(vdot(Chouff,Rotada(0,1,0))), abs(vdot(Chouff,Rotada(0,0,1)))>
          ;
          #local Penetreixon=min(Penetr.x,Penetr.y,Penetr.z);
          #switch(Penetreixon)
            #case(Penetr.x)
              #local Chant=-Penetreixon*vdot(Chouff,Rotada(1,0,0))/abs(vdot(Chouff,Rotada(1,0,0)))*Rotada(1,0,0);
            #break
            #case(Penetr.y)
              #local Chant=-Penetreixon*vdot(Chouff,Rotada(0,1,0))/abs(vdot(Chouff,Rotada(0,1,0)))*Rotada(0,1,0);
            #break
            #case(Penetr.z)
              #local Chant=-Penetreixon*vdot(Chouff,Rotada(0,0,1))/abs(vdot(Chouff,Rotada(0,0,1)))*Rotada(0,0,1);
            #break
          #else
            #error "Semelha haver um erro de calculo."
          #end
          #local VelRel=MecXos_Velocidades[CorpoActual][ElementoActual]-MecXos_VelocidadesCM[ContaDaus]-vcross(MecXos_VelocidadesAngulares[ContaDaus],Chouff);
          #local Transvers=vdot(VelRel,vnormalize(Chant))*vnormalize(Chant);
          #local Escorreg=VelRel-Transvers;
          #if(vlength(Escorreg)=0)
            #local DirEsvar=<0,0,0>;
          #else
            #local DirEsvar=vnormalize(Escorreg);
          #end
          #local Reacc = RigDados*vlength(Chant)* ( vnormalize(Chant) +
            CoefAtritoDados*DirEsvar ) +
            AmortDadosN*Transvers +
            AmortDadosT*Escorreg
          ;
          #declare Resultante=Resultante-Reacc;
          #local Rod=MecXos_VelocidadesAngulares[ContaDaus]-MecXos_VelocidadesAngulares[CorpoActual];
          #local Piv=vdot(Rod,vnormalize(Chant))*vnormalize(Chant);
          #declare Rod=Rod-Piv;
          #declare Momento=Momento-vcross(Chouff,Reacc)+CoefRodaduraDados*Rod+CoefPivotamentoDados*Piv;
          #undef Rotada
        #end
      #end
      #declare ContaDaus=ContaDaus+1;
    #end
  #end
#end

MovSolRigCampoDeForcas("Dadeixos", Nos, Freq, Poss, Inzinhas, VelIniciais, VelAngIniciais, Tempo, 0)

light_source{
  1e6*<20,30,-15> rgb 1.6 parallel point_at 0
  #if(LuzExtensa)
    area_light 2*1e6*x, 2*1e6*y, 4, 4  circular orient
    adaptive 0
  #end
  #if(Fotons)
    photons{
      refraction on
      reflection on
      #if(LuzExtensa) area_light #end
    }
  #end
}


plane{  //  Cho
  y, 0
  texture{
    checker
      texture{
        pigment{rgb<1,.3,0>} normal{agate agate_turb 1}
        finish{diffuse .5 specular .3 roughness .01 irid{.2 thickness 5 turbulence 1}}
      }
      texture{
        pigment{rgb<0,.8,.7>} normal{wrinkles scale .3}
        finish{diffuse .5 specular .6 roughness .002 reflection{.1 .5}}
      }
  }
}


#declare ContaDados=0;
#while(ContaDados<QuantosDados)
  difference{
    merge{
      box{Arestas[ContaDados]/2-<0,1,1>*RaiosRedond[ContaDados],-Arestas[ContaDados]/2+<0,1,1>*RaiosRedond[ContaDados]}
      box{Arestas[ContaDados]/2-<1,0,1>*RaiosRedond[ContaDados],-Arestas[ContaDados]/2+<1,0,1>*RaiosRedond[ContaDados]}
      box{Arestas[ContaDados]/2-<1,1,0>*RaiosRedond[ContaDados],-Arestas[ContaDados]/2+<1,1,0>*RaiosRedond[ContaDados]}
      cylinder{< 1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),< 1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),< 1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),< 1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),< 1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{< 1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{<-1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{<-1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{<-1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      cylinder{<-1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]),<-1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{< 1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{< 1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{< 1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{< 1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{<-1, 1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{<-1, 1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{<-1,-1, 1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      sphere{<-1,-1,-1>*(Arestas[ContaDados]/2-RaiosRedond[ContaDados]), RaiosRedond[ContaDados]}
      texture{
        pigment{CorCorpo[ContaDados]}
        finish{FinishCorpo[ContaDados]}
      }
      photons{collect RecolheFotonsCorpo[ContaDados]}
    }
    union{
      sphere{ // Nmero 1
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<-1/2,0,0>
      }
      sphere{ // Nmero 6
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/2,-1/4,-1/4>
      }
      sphere{ // Nmero 6
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/2,-1/4,1/4>
      }
      sphere{ // Nmero 6
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/2,0,-1/4>
      }
      sphere{ // Nmero 6
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/2,0,1/4>
      }
      sphere{ // Nmero 6
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/2,1/4,-1/4>
      }
      sphere{ // Nmero 6
        0, 1 scale<EixPontos[ContaDados].v,EixPontos[ContaDados].u,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/2,1/4,1/4>
      }
      sphere{ // Nmero 2
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<-1/4,-1/2,-1/4>
      }
      sphere{ // Nmero 2
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/4,-1/2,1/4>
      }
      sphere{ // Nmero 5
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<-1/4,1/2,-1/4>
      }
      sphere{ // Nmero 5
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<-1/4,1/2,1/4>
      }
      sphere{ // Nmero 5
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/4,1/2,-1/4>
      }
      sphere{ // Nmero 5
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<1/4,1/2,1/4>
      }
      sphere{ // Nmero 5
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].v,EixPontos[ContaDados].u>
        translate Arestas[ContaDados]*<0,1/2,0>
      }
      sphere{ // Nmero 3
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<-1/4,-1/4,-1/2>
      }
      sphere{ // Nmero 3
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<0,0,-1/2>
      }
      sphere{ // Nmero 3
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<1/4,1/4,-1/2>
      }
      sphere{ // Nmero 4
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<-1/4,-1/4,1/2>
      }
      sphere{ // Nmero 4
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<-1/4,1/4,1/2>
      }
      sphere{ // Nmero 4
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<1/4,-1/4,1/2>
      }
      sphere{ // Nmero 4
        0, 1 scale<EixPontos[ContaDados].u,EixPontos[ContaDados].u,EixPontos[ContaDados].v>
        translate Arestas[ContaDados]*<1/4,1/4,1/2>
      }
      texture{
        pigment{CorPontos[ContaDados]}
        finish{FinishPontos[ContaDados]}
      }
    }
    interior{Interior[ContaDados]}
    #if(Fotons)
      photons{target 1 refraction on reflection on}
    #end
    transform{RotIniciais[ContaDados] MecXos_Rotacoes[ContaDados]} translate MecXos_CMs[ContaDados]
  }
  #declare ContaDados=ContaDados+1;
#end


//---------------------------------- Defini da cmara ---------------------------------------------------

#declare Estereoscopia_Olho=1-2*mod(frame_number,2);
#declare Estereoscopia_DistOlhos=.06;

#declare Estereoscopia_TipoDeCamara=0;   //Projec cnica (perspectiva), a predeterminada
//#declare Estereoscopia_TipoDeCamara=1;   //Projec ortogonal
//#declare Estereoscopia_TipoDeCamara=2;   //Olho de peixe (esfrica polar)
//#declare Estereoscopia_TipoDeCamara=3;   //Gram angular
//#declare Estereoscopia_TipoDeCamara=4;   //Omnimax
//#declare Estereoscopia_TipoDeCamara=5;   //Panormica
//#declare Estereoscopia_TipoDeCamara=6;   //Cilindro vertical, ponto de vista fixo
//#declare Estereoscopia_TipoDeCamara=7;   //Cilindro horizontal, ponto de vista fixo
//#declare Estereoscopia_TipoDeCamara=8;   //Cilindro vertical, ponto de vista mvel
//#declare Estereoscopia_TipoDeCamara=9;   //Cilindro horizontal, ponto de vista mvel
//#declare Estereoscopia_TipoDeCamara=10;  //Esfrica cartesiana

#declare Sencho=<0,0,0>;
#declare Desv=0;
#declare ContaDados=0;
#while(ContaDados<QuantosDados)
  #declare Sencho=Sencho+MecXos_CMs[ContaDados];
  #declare Desv=Desv+pow(MecXos_CMs[ContaDados].x,2)+pow(MecXos_CMs[ContaDados].y,2);
  #declare ContaDados=ContaDados+1;
#end
#declare Sencho=Sencho/QuantosDados;
#declare Desv=sqrt(Desv/QuantosDados-pow(Sencho.x,2)-pow(Sencho.y,2));

#declare ParamCam=MaxAtrasoCamara/.468914153;
#declare ParamMot=MaxAtrasoMotivo/.468914153;

#declare AfastCamara=3*FactAfastCamara*(Desv+sqrt(3)*MaxAresta);

#declare Estereoscopia_UbiCamara=
  Sencho +
  < DesvHCamara ,
    AltCamara-ParamCam/(ParamCam/Sencho.y+sinh(Sencho.y/ParamCam)) ,
    -AfastCamara
  >
;
#declare Estereoscopia_Largo=x;
#declare Estereoscopia_Alto=y;
#declare Estereoscopia_Focal=3*z;
#declare Estereoscopia_CeuCamara=y;
//#declare Estereoscopia_AngCamara=25;
//#declare Estereoscopia_AngCamara2=<180,90>;
#declare Estereoscopia_OlhaCara=Sencho-ParamMot/(ParamMot/Sencho.y+sinh(Sencho.y/ParamMot))*y;

//#declare Estereoscopia_TransformaCamara=transform{translate 0}  //Transforma que se impor  cmara
                                                              //sobre todas as opes anteriores

#include "Estereoscopia.inc"


//----------------------------------------------------------------------------------------------------------

fog{fog_type 1 distance 2*AfastCamara color rgb<0,.001,.02>}
