// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Duplas paginas.inc
// Vers: 3.6
// Descri: Determina quais imagens utilizar o arquivo de cena Duplas paginas.pov.
// Data de cria: 4-XI-2004
// Data da ltima actualiza: 15-XI-2005
// Autor: Xos B. Carballeira Rabual


#local versDuplasPaginas=version;
#version 3.6;

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Duplas paginas.inc\", que determina quais imagens utilizara o \"Duplas paginas.pov\"\n"
#end

#macro DuplaPagina(Indice)
  #local Resultado=pigment{
    image_map{
      png
      #switch(Indice)
        #case(1)
          "Dados pessoais.png"
        #break
        #case(2)
          "Horario.png"
        #break
        #case(3)
          "Professores e materias.png"
        #break
        #range(4,65)
          concat("Principal",str(Indice-3,-2,0),".png")
        #break
        #range(66,70)
          concat("Notas",str(Indice-65,-1,0),".png")
        #break
        #case(71)
          "Qualificacoes e leituras.png"
        #break
        #case(72)
          "Vocabulario.png"
        #break
        #case(73)
          "Gente.png"
        #break
      #else
        "Blank.png"
      #end
      once
      interpolate 2
      //interpolate 4
    }
  }
  Resultado
#end

#version versDuplasPaginas;