// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Estereoscopia.inc
// Vers: 3.5
// Descri: Ajuda a criar parelhas de imagens estereoscpicas.
// Data de cria: 1-XI-2002
// Autor: Xos B. Carballeira Rabual

#local versionEstereoscopia=version;
#version 3.5;

/****************************************** INSTRUES *****************************************************

               **HAI-NAS QUE ESCREVER**

*************************************************************************************************************/

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Estereoscopia.inc\", que ajuda a criar parelhas estereoscopicas de imagens.\n"
#end

#ifndef(Estereoscopia_Olho)
  #declare Estereoscopia_Olho=0;  //Olho central
#end
#ifndef(Estereoscopia_DistOlhos)
  #declare Estereoscopia_DistOlhos=.06;
#end

#ifndef(Estereoscopia_TipoDeCamara)
  #declare Estereoscopia_TipoDeCamara=0;  //Perspectiva
#end

//Todo este conhao para encher os dados omitidos.
#if(defined(Estereoscopia_Largo)&defined(Estereoscopia_Alto)&defined(Estereoscopia_Focal))
  #declare Xose_SRDextrogiro=(vdot(Estereoscopia_Largo,vcross(Estereoscopia_Alto,Estereoscopia_Focal))<0);
#else
  #ifndef(Xose_SRDextrogiro)
    #declare Xose_SRDextrogiro=false;
  #end
  #ifdef(Estereoscopia_Largo)
    #ifdef(Estereoscopia_Alto)
      #local Raskanderzlats=(Xose_SRDextrogiro? 1: -1)*vcross(Estereoscopia_Alto,Estereoscopia_Largo);
      #if(vlength(Raskanderzlats)=0)
        #declare Raskanderzlats=vcross((Xose_SRDextrogiro? z: -y),Estereoscopia_Largo);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=(Xose_SRDextrogiro? y: z);
        #end
      #end
      #declare Estereoscopia_Focal=9/4*vlength(Estereoscopia_Largo)*vnormalize(Raskanderzlats);
    #else
      #ifdef(Estereoscopia_Focal)
        #local Raskanderzlats=(Xose_SRDextrogiro? 1: -1)*vcross(Estereoscopia_Largo,Estereoscopia_Focal);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=vcross( Estereoscopia_Largo,
            vcross((Xose_SRDextrogiro? z: y),Estereoscopia_Largo) );
          #if(vlength(Raskanderzlats)=0)
            #declare Raskanderzlats=select(vdot((Xose_SRDextrogiro? z: y),Estereoscopia_Largo),1,-1)*x;
          #end
        #end
        #declare Estereoscopia_Alto=3/4*vlength(Estereoscopia_Largo)*vnormalize(Raskanderzlats);
      #else
        #local Raskanderzlats=vcross((Xose_SRDextrogiro? z: -y),Estereoscopia_Largo);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=(Xose_SRDextrogiro? y: z);
        #end
        #declare Estereoscopia_Focal=9/4*vlength(Estereoscopia_Largo)*vnormalize(Raskanderzlats);
        #declare Estereoscopia_Alto=3/4*(Xose_SRDextrogiro? 1: -1)*vlength(Estereoscopia_Largo) *
          vnormalize(vcross(Estereoscopia_Largo,Raskanderzlats));
      #end
    #end
  #else
    #ifdef(Estereoscopia_Alto)
      #ifdef(Estereoscopia_Focal)
        #local Raskanderzlats=(Xose_SRDextrogiro? 1: -1)*vcross(Estereoscopia_Focal,Estereoscopia_Alto);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=vcross(Estereoscopia_Alto,(Xose_SRDextrogiro? z: -y));
          #if(vlength(Raskanderzlats)=0)
            #declare Raskanderzlats=x;
          #end
        #end
        #declare Estereoscopia_Largo=4/3*vlength(Estereoscopia_Alto)*vnormalize(Raskanderzlats);
      #else
        #local Raskanderzlats=vcross(Estereoscopia_Alto,(Xose_SRDextrogiro? z: -y));
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=x;
        #end
        #declare Estereoscopia_Largo=4/3*vlength(Estereoscopia_Alto)*vnormalize(Raskanderzlats);
        #declare Estereoscopia_Focal=3*(Xose_SRDextrogiro? 1: -1)*vlength(Estereoscopia_Alto) *
          vnormalize(vcross(Estereoscopia_Alto,Raskanderzlats));
      #end
    #else
      #ifdef(Estereoscopia_Focal)
        #local Raskanderzlats=vcross(Estereoscopia_Focal,(Xose_SRDextrogiro? z: -y));
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=x;
        #end
        #declare Estereoscopia_Largo=4/9*vlength(Estereoscopia_Focal)*vnormalize(Raskanderzlats);
        #declare Estereoscopia_Alto=(Xose_SRDextrogiro? 1: -1)/3*vlength(Estereoscopia_Focal)*
          vnormalize(vcross(Raskanderzlats,Estereoscopia_Focal));
      #else
        #declare Estereoscopia_Largo=4/3*x;
        #declare Estereoscopia_Alto=(Xose_SRDextrogiro? z: y);
        #declare Estereoscopia_Focal=3*(Xose_SRDextrogiro? y: z);
      #end
    #end
  #end
#end

#ifndef(Estereoscopia_UbiCamara)
  #declare Estereoscopia_UbiCamara=<0,0,0>;
#end
#ifndef(Estereoscopia_CeuCamara)
  #if(Xose_SRDextrogiro)
    #declare Estereoscopia_CeuCamara=z;
  #else
    #declare Estereoscopia_CeuCamara=y;
  #end
#end
#if(defined(Estereoscopia_AngCamara)&(Estereoscopia_TipoDeCamara<2))
  #declare Estereoscopia_Focal=
    vlength(Estereoscopia_Largo)/(2*tan(Estereoscopia_AngCamara/2))*vnormalize(Estereoscopia_Focal);
#end

camera{
  #switch(Estereoscopia_TipoDeCamara)
    #case(0)
      perspective
    #break
    #case(1)
      orthographic
    #break
    #case(2)
      fisheye
    #break
    #case(3)
      ultra_wide_angle
    #break
    #case(4)
      omnimax
    #break
    #case(5)
      panoramic
    #break
    #case(6)
      cylinder 1
    #break
    #case(7)
      cylinder 2
    #break
    #case(8)
      cylinder 3
    #break
    #case(9)
      cylinder 4
    #break
    #case(10)
      spherical
    #break
  #end
  #local Narigudem=select(Estereoscopia_Olho,-1,0,1)/2*Estereoscopia_DistOlhos;
  #ifdef(Estereoscopia_OlhaCara)
    #local Prekauxion=(Xose_SRDextrogiro? 1: -1) *
      vcross(Estereoscopia_OlhaCara-Estereoscopia_UbiCamara,Estereoscopia_CeuCamara);
    #if(vlength(Prekauxion)=0)
      #declare Prekauxion=Estereoscopia_Largo;
    #end
    #local Chufloup=Narigudem*vnormalize(Prekauxion);
  #else
    #local Chufloup=Narigudem*vnormalize(Estereoscopia_Largo);
  #end
  location Estereoscopia_UbiCamara+Chufloup
  right Estereoscopia_Largo
  up Estereoscopia_Alto
  direction Estereoscopia_Focal
  sky Estereoscopia_CeuCamara
  #ifdef(Estereoscopia_AngCamara)
    angle Estereoscopia_AngCamara
  #end
  #if((Estereoscopia_TipoDeCamara=10)&defined(Estereoscopia_AngCamara2))
    angle Estereoscopia_AngCamara2.u, Estereoscopia_AngCamara2.v
  #end
  #ifdef(Estereoscopia_OlhaCara)
    look_at Estereoscopia_OlhaCara
  #end
  #ifdef(Estereoscopia_TransformaCamara)
    transform Estereoscopia_TransformaCamara
  #end
}


#version versionEstereoscopia;