// Arquivo principal de cena para o traador de raios de Persistence of Vision
// Arquivo: Experimento matricial.pov
// Vers: 3.6
// Descri: Prova sobre certas inquedanas relativamente  fun exponencial avaliada nas
                                                                         //matrizes complexas.
// Data de cria: 12-VIII-2005 
// Data da ltima actualiza: _
// Autor: Xos Benito Carballeira Rabual

// Esta cena requer os arquivo CALIST.TTF e CALISTI.TTF, que definem os tipos de letra
                                   // Calisto MT Normal e Calisto MT Cursiva, respectivamente.
// +w700 +h150

#version 3.6;

#include "Matematica.inc"

//============================================== OPES ==================================================

#declare QuantasCifrasSignificativas=2;
#declare Matriz=array[3][3]/*{
  {-1, 0, 0}
  {0, -1, 0}
  {0, 0, 1}
}*/
//#declare Matriz=MEscalar(-35,3,3)
#declare Afeixe=seed(23);
#declare Fila=0;
#while(Fila<dimension_size(Matriz,1))
  #declare Col=0;
  #while(Col<dimension_size(Matriz,2))
    #declare Matriz[Fila][Col]=1.5*(2*rand(Afeixe)-1);
    #declare Col=Col+1;
  #end
  #declare Fila=Fila+1;
#end

#declare Matriz2=MNula(dimension_size(Matriz,1),dimension_size(Matriz,2))
#declare Matriz3=MNula(dimension_size(Matriz,1),dimension_size(Matriz,2))
#declare Matriz4=MNula(dimension_size(Matriz,1),dimension_size(Matriz,2))

#declare Freixo=array[3][3]{
  {.5, -.8, 0}
  {1, .5, 0}
  {0, 0, 1}
}

#declare Pai=384;

#declare Ponteirolo=0;
#while(Ponteirolo<1)
  #declare Matriz2=PotM(Matriz,Pai)
  #declare Matriz3=PotM_Velha(Matriz,Pai)
  //#declare Matriz4=RaizMNewtonRaphson(pow(2,-frame_number), 1e10, frame_number, Matriz2, Pai, SomaM(Matriz,ProdEscM(1/1000,Freixo)), false)
  #declare Ponteirolo=Ponteirolo+1;
#end

//#declare Matriz=AvalPolM(PolCarM(Matriz),Matriz)
//#declare Matriz=AvalPolM(array[5]{4687.0342,1147.6713,11.56501075,4.6060524,1},Matriz)

//#declare Escalar=Factorial(frame_number+100);

//=============================================== CENA ===================================================

global_settings{
  assumed_gamma 1
}

camera{
  orthographic
  location -2*z
  right 4/3*x
  up y
  direction z
  look_at 0
}

//background{rgb<1,1,1>}

#macro Matrosco(Matiz)
  union{
    #declare Paren1=text{ttf "CALIST.TTF", "(", .01, 0 scale<.1,1,1>}
    #declare Paren1=object{Paren1 scale 1/(max_extent(Paren1).y-min_extent(Paren1).y)}
    #declare Paren2=text{ttf "CALIST.TTF", ")", .01, 0 scale<.1,1,1>}
    #declare Paren2=object{Paren2 scale 1/(max_extent(Paren2).y-min_extent(Paren2).y)}
    #declare Largo=4/3-(max_extent(Paren1).x-min_extent(Paren1).x)-(max_extent(Paren2).x-min_extent(Paren2).x);
    object{Paren1 translate<-2/3, -(max_extent(Paren1).y+min_extent(Paren1).y)/2, 0>}
    object{Paren2 translate<2/3-(max_extent(Paren2).x-min_extent(Paren2).x), -(max_extent(Paren1).y+min_extent(Paren1).y)/2, 0>}
    #declare Fila=0;
    #while(Fila<dimension_size(Matiz,1))
      #declare Col=0;
      #while(Col<dimension_size(Matiz,2))
        #declare Num=text{ttf "CALIST.TTF", NotacoCientifica(Matiz[Fila][Col],QuantasCifrasSignificativas), .01, 0}
        object{ Num
          scale <.7*Largo/dimension_size(Matiz,2),.7/dimension_size(Matiz,1),1> /
            ((max_extent(Num)-min_extent(Num))*<1,1,0>+<0,0,1>)
          translate<Largo*(-.45+Col/dimension_size(Matiz,2)),.55-(Fila+1)/dimension_size(Matiz,1),0>
        }
        #declare Col=Col+1;
      #end
      #declare Fila=Fila+1;
    #end
  }
#end

union{

  /*#declare Coefs=PolCarM(Matriz)
  #declare Conta=0;
  #while(Conta<dimension_size(Coefs,1))
    #declare Num=text{ttf "CALIST.TTF", NotacoCientifica(Coefs[Conta],QuantasCifrasSignificativas), .01, 0 scale<.04,.1,1> translate<-.65+.2*Conta,-.25,0>}
    object{Num}
    #declare Conta=Conta+1;
  #end*/
  /*#declare Num=text{ttf "CALIST.TTF", NotacoCientifica(Escalar,QuantasCifrasSignificativas), .01, 0}
  object{
    Num translate -(max_extent(Num)+min_extent(Num))/2 scale <.4,.1,1>/((max_extent(Num)-min_extent(Num))*<1,1,0>+<0,0,1>)
    translate .3*x
  }
  #declare Num2=text{ttf "CALIST.TTF", NotacoCientifica(frame_number+100,QuantasCifrasSignificativas), .01, 0}
  object{
    Num2 translate -(max_extent(Num)+min_extent(Num))/2 scale <.4,.1,1>/((max_extent(Num)-min_extent(Num))*<1,1,0>+<0,0,1>)
    translate -.3*x
  }*/
  object{Matrosco(Matriz) scale<.2,.4,1> translate<-.5,0,0>}
  object{Matrosco(Matriz2) scale<.2,.4,1> translate<-.15,0,0>}
  object{Matrosco(Matriz3) scale<.2,.4,1> translate<.15,0,0>}
  object{Matrosco(Matriz4) scale<.2,.4,1> translate<.5,0,0>}/**/
  
  pigment{rgb<1,.5,.5>} finish{ambient 1}
}