// Arquivo principal de cena para o traador de raios de Persistence of Vision
// Arquivo: Fervor.pov
// Vers: 3.5
// Descri: Um vaso de vidro com um lquido vermelho a ferver
// Data de cria: 21-V-2003
// Data da ltima actualiza: 23-V-2003
// Autor: Xos B. Carballeira Rabual

// Tardou 19h 48 39 no meu AMD Athlon, 1.600 ou 1.700?:
// +w800 +h600

#version 3.5;

global_settings{
  assumed_gamma 1
  max_trace_level 100
  ambient_light .5
  photons{
    spacing 0.001
    save_file concat(Xose_PastaTemp, "\\Fotazooo...!")
    //load_file concat(Xose_PastaTemp, "\\Fotazooo...!")
    autostop 0
  }
}

camera{
  location<.2,.2,-.5>
  right 4/3*x
  up y
  direction 3*z
  look_at .07*y
  aperture .02 focal_point .07*y blur_samples 20 confidence .7 variance 1/4000
}

sky_sphere{
  pigment{
    gradient y colour_map{
      [.43 rgb<0,.16,.06>]
      [.5 rgb<.05,.3,.2>]
    }
    scale 2 translate -y
  }
}

light_source{
  <1,.5,-.2>
  rgb 200 fade_distance .1 fade_power 2 media_interaction on media_attenuation off
  //rgb 1
  photons {
    refraction on
    reflection on
  }

}

// Mesa
disc{0, y, 1
  pigment{
    ripples colour_map{
      [0 rgb<.3,.2,.05>]
      [.3 rgb<.6,.5,.2>]
      [.6 rgb<.2,.2,.1>]
      [.8 rgb<.6,.3,.1>]
      [1 rgb<.3,.2,.05>]
    }
    ramp_wave frequency 30 warp{turbulence .1 lambda 3.5 omega .4}
    scale 10 rotate<20,48,0> translate .2*y
  }
  normal{bumps .5 scale .01 warp{turbulence .1}}
  finish{ambient .05 diffuse .8 brilliance 1.2 specular .8 roughness .005}
}

// Vaso
difference{
  sor{
    6,
    <0, 0>,
    <.035, .0001>,
    <.04, .095>,
    <.04, .0985>,
    <.0385, .10>,
    <0, .104>
    //sturm
  }
  sor{
    6,
    <0, .003>,
    <.032, .00301>,
    <.037, .095>,
    <.037, .0985>,
    <.0385, .10001>,
    <.06, .104>
    //sturm
  }
  translate .0003*y
  pigment{rgbf<.7,1,.9,1>}
  finish{
    ambient 0
    diffuse .3 brilliance 2
    specular .8 roughness .001
    reflection{0, .5 fresnel}
    conserve_energy
  }
  interior {
    ior 1.5
    dispersion 1.01 dispersion_samples 7
    //caustics .8
  }
  photons{
    target 1
    refraction on
    reflection off
    collect off
  }
}

// Lquido
#local TexLiq=texture{
  pigment{rgbf<1,.2,.2,1>}
  finish{
    diffuse .8
    specular .8 roughness .001
    reflection{0, .5 fresnel}
  }
}
#declare NoDeBurbulhas=100;
#local ContaBurbulhas=0;
#local EtamerEdOlot=seed(23498);
#local Guarrameda=array[NoDeBurbulhas]
#local GaloMerdeiro=0;
#while(ContaBurbulhas<NoDeBurbulhas)
  #declare GaloMerdeiro=2*pi*rand(EtamerEdOlot);
  #declare Guarrameda[ContaBurbulhas]=(.07*rand(EtamerEdOlot))*<0,1,0,0> +
    .04*sqrt(rand(EtamerEdOlot))*<cos(GaloMerdeiro),0,sin(GaloMerdeiro),0> +
    (.008*pow(rand(EtamerEdOlot),10)+.002)*t;
  #declare ContaBurbulhas=ContaBurbulhas+1;
#end
intersection{
  sor{
    6,
    <0, .003>,
    <.032, .00301>,
    <.037, .095>,
    <.037, .0985>,
    <.0385, .10001>,
    <.06, .104>
    //sturm
    translate -.003*y scale .97 translate .0035*y
  }
  merge{
    plane{y, .06 texture{TexLiq normal{bumps .5 warp{turbulence .1} scale .02 translate 1}}} //Cumpre perturbar essa superfcie um chisco.
    #declare ContaBurbulhas=0;
    #while(ContaBurbulhas<NoDeBurbulhas)
      sphere{<Guarrameda[ContaBurbulhas].x,Guarrameda[ContaBurbulhas].y,Guarrameda[ContaBurbulhas].z>,
        Guarrameda[ContaBurbulhas].t+.0001
      }
      #declare ContaBurbulhas=ContaBurbulhas+1;
    #end
  }
  #declare ContaBurbulhas=0;
  #while(ContaBurbulhas<NoDeBurbulhas)
    sphere{<Guarrameda[ContaBurbulhas].x,Guarrameda[ContaBurbulhas].y,Guarrameda[ContaBurbulhas].z>,
      Guarrameda[ContaBurbulhas].t inverse
    }
    #declare ContaBurbulhas=ContaBurbulhas+1;
  #end
  bounded_by{cylinder{0, .08*y, .04}}
  texture{TexLiq}
  interior{
    ior 1.33
    dispersion 1.008 dispersion_samples 7
    //caustics .8
  }
  photons{
    target 1
    refraction on
    reflection off
    collect off
  }
}

// Nuvinhas de vapor condensado
union{
  #declare ContaBurbulhas=0;
  #declare EtamerEdOlot=seed(7958);
  #while(ContaBurbulhas<100)
    #declare GaloMerdeiro=2*pi*rand(EtamerEdOlot);
    #declare PitaDoMonte=2*pi*rand(EtamerEdOlot);
    #declare FaisamTrufado=1-.1*rand(EtamerEdOlot);
    #declare ParruloALaranja=pow(rand(EtamerEdOlot),.4)/3;
    union{
      sphere{0, 1
        interior{
          ior 1.0005
          media{
            intervals 1
            samples 1
            confidence .6
            variance 1/64
            scattering{2, rgb 3}
            method 3
            aa_level 3
            aa_threshold .3
            density{
              spherical colour_map{
                [0 rgb 0]
                [.2 rgb 1]
                [1 rgb 0]
              }
              warp{turbulence .5}
            }
          }
        }
      }
      sphere{0, .5 interior{ior 1.001}}
      scale .0195*rand(EtamerEdOlot)
      translate .02*sqrt(rand(EtamerEdOlot))*<cos(GaloMerdeiro),0,sin(GaloMerdeiro)>+.06*y +
        (.3*rand(EtamerEdOlot)+.3)*ParruloALaranja *
        (sqrt(1-pow(FaisamTrufado,2))*(cos(PitaDoMonte)*x+sin(PitaDoMonte)*z)+FaisanTrufado*y) -
        .15*pow(ParruloALaranja,2)*y
    }
    #declare ContaBurbulhas=ContaBurbulhas+1;
  #end
  hollow
  pigment{rgbt 1}
  finish{ambient 0 diffuse 0}
  photons{collect off}
}