// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Figurinhas de Matematicas, Fisica e Quimica.inc
// Vers: 3.5
// Descri: Diversos elementos para cenas relativas s Matemticas,  Fsica ou  Qumica
// Data de cria: II-2002
// Autor: Xos B. Carballeira Rabual

#local versionDbxnhsMtFisQ=version;
#version 3.5;

#ifndef(Xose_SemTexturas)
  #declare Xose_SemTexturas=false;
#end

#declare Bola = sphere{0, 1
  #if(!Xose_SemTexturas)
    texture{
      pigment{rgb<0,.5,.05>}
      finish{
        diffuse .7 brilliance 4
        specular .7 roughness .0001 metallic
        reflection{.2
          metallic
          //exponent 1
        }
      }
    }
  #end
}

#macro FlechaRecta(Origem, Extremo, Grosso, LongitudeDaPonta)
  merge{
    cylinder{Origem, Extremo-min(LongitudeDaPunta,vlength(Extremo-Origem)/2)*vnormalize(Extremo-Origem)*2/3, Grosso/2}
    cone{Extremo-min(LongitudeDaPunta,vlength(Extremo-Origem)/2)*vnormalize(Extremo-Origem), Grosso*2/2, Extremo, 0}
    #if(!Xose_SemTexturas)
      texture{
        pigment{rgbf<.8,.03,0,.9>}
        finish{
          diffuse .8 brilliance 4
          specular .7 roughness .001
          reflection{.1, .2
            fresnel
            //exponent 1
          }
          conserve_energy
        }
      }
      interior{
        ior 1.5
      }
    #end
  }
#end

#macro FlechaCircular(Centro, DireccInicial, VectAng, Radio, Grosso, LongitudeDaPunta)
  #if(vlength(VectAng)!=0)
    #local DireccInicial =
      vnormalize(DireccInicial-vdot(DireccInicial,vnormalize(VectAng))*vnormalize(VectAng));
    #local Refaixo=min(LongitudeDaPunta/Radio,vlength(VectAng)/2);
    merge{
      intersection{
        torus{Radio, Grosso/2
          #local VectEixo=vcross(y,VectAng);
          #if(vlength(VectEixo))
            #local VectEixo=vnormalize(VectEixo);
            #local Phi=acos(vdot(y,vnormalize(VectAng)));
            #if(VectEixo.z|VectEixo.y)
              #local Axuste=atan2(VectEixo.z,VectEixo.y);
            #else
              #local Axuste=0;
            #end
            rotate<degrees(-Axuste),0,degrees(-acos(VectEixo.x))>
            rotate<degrees(Phi),0,degrees(acos(VectEixo.x))>
            rotate<degrees(Axuste),0,0>
          #end
        }
        #if(vlength(VectAng)<pi) intersection #else merge #end {
          plane{vcross(DireccInicial,VectAng), 0}
          plane{
            vcross(VectAng,vaxis_rotate(DireccInicial,VectAng,degrees(vlength(VectAng)-Refaixo*2/3))), 0
          }
        }
      }
      #local Extremo=vaxis_rotate(Radio*DireccInicial,VectAng,degrees(vlength(VectAng)));
      cone{
        vaxis_rotate(Extremo,VectAng,degrees(-Refaixo)), Grosso*2/2,
        Extremo, 0
      }
      translate Centro
      #if(!Xose_SemTexturas)
        texture{
          pigment{rgbf<.8,.03,0,.9>}
          finish{
            diffuse .8 brilliance 4
            specular .7 roughness .001
            reflection{.1, .2
              fresnel
              //exponent 1
            }
            conserve_energy
          }
        }
        interior{
          ior 1.5
        }
      #end
    }
  #end
#end

//J continuaremos...

#version versionDbxnhsMtFisQ;