// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Fogar.inc
// Vers: 3.6
// Descri: Objectos domsticos. A unidade de longitude  o metro.
// Data de cria: 4-VI-2003; procede do velho Obxectos de Xose.inc, criado o 17-IV-2002.
// Data da ltima actualiza: 27-VII-2004 (actualizei-o para a vers 3.6)
// Autor: Xos B. Carballeira Rabual


#local versionGlebFogo=version;
#version 3.6;

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Fogar.inc\", que define objectos domesticos.\n"
#end

#ifndef(Xose_SemTexturas)
  #declare Xose_SemTexturas=false;
#end


#declare Mesa=union{
  superellipsoid{<.1,.1>
    scale<.65,.04,.35>
    translate<0,.78,0>
  }
  #local Pataca=sor{
    15,
    <0,0>,<1.4664,1.1048>,<1.0588,2.5408>,
    <1.8770,6.0281>,<3.1087,14.0283>,
    <2.4864,26.6681>,<2.2462,30.269>,
    <4.6486,32.0695>,<6.4505,32.7896>,
    <1.8858,35.1902>,<5.4895,36.2705>,
    <2.2875,37.8238>,<3.1087,42.1317>,
    <3.5193,48.6959>,<0,48.6960>
    scale<.015,.78/48.6959,.015>
  }
  object{Pataca translate<-.4,0,-.2>}
  object{Pataca translate<.4,0,-.2>}
  object{Pataca translate<-.4,0,.2>}
  object{Pataca translate<.4,0,.2>}
  #if(!Xose_SemTexturas)
    texture{
      pigment{
        wood colour_map{
          [0 rgb<.5,.2,.1>]
          [.3 rgb<.15,.07,.01>]
          [.5 rgb<.4,.2,.07>]
          [.8 rgb<.6,.37,.1>]
          [1 rgb<.5,.2,.1>]
        }
        turbulence .1
        scale .05 rotate<30,60,0> translate<.3,.4,.2>
      }
      finish{
        diffuse .8 brilliance 2
        specular .7 roughness .01
      }
    }
  #end
}

#macro VasoComLiquido(DiametroSup, DiametroInf, Altura, GrossoDasParedes, GrossoDoFundo, MatVaso,
  QuantoDeCheio, Liquido)
  #local GrossoAparente=GrossoDasParedes/cos(atan2(DiametroSup-DiametroInf,2*Altura));
  union{
    difference{
      cone{<0,0,0>,DiametroInf/2,<0,Altura,0>,DiametroSup/2}
      cone{
        <0,GrossoDoFundo,0>,
        (DiametroInf+(DiametroSup-DiametroInf)*GrossoDoFundo/Altura)/2-GrossoAparente,
        <0,2*Altura,0>,DiametroInf/2+DiametroSup-DiametroInf-GrossoAparente
      }
      #if(!Xose_SemTexturas) material{MatVaso} #end
    }
    #local MinAltDoLiq=GrossoDoFundo+1e-7*(Altura-GrossoDoFundo);
    #local MaxAltDoLiq=MinAltDoLiq+QuantoDeCheio*(Altura-MinAltDoLiq);
    #local GrosApProLiq=GrossoAparente +
      1e-7*(DiametroInf+min((DiametroSup-DiametroInf)*MinAltDoLiq/Altura,
      (DiametroSup-DiametroInf)*MaxAltDoLiq/Altura)-GrossoAparente)/2;
    cone{
      <0,MinAltDoLiq,0>,(DiametroInf+(DiametroSup-DiametroInf)*MinAltDoLiq/Altura)/2-GrosApProLiq,
      <0,MaxAltDoLiq,0>,(DiametroInf+(DiametroSup-DiametroInf)*MaxAltDoLiq/Altura)/2-GrosApProLiq
      hollow
      #if(!Xose_SemTexturas) material{Liquido} #end
    }
  }
#end


#version versionGlebFogo;