// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Ilhas da bruxa.pov
// Vers: 3.5
// Descri: Umha das minhas primeiras animaes
// Data: Comeos do 2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

#declare xCam = -800*clock+400  ;
#declare yCam = 100+10*sin(40*pi*clock) ;
#declare zCam = -800*pow(2*clock-1,2)+400;            
              
camera {  //orthographic
    location <xCam,yCam,zCam>//<0,100 , -200> 
    right 12*<1,0,0> up 12*<0,.75,0>
    //direction <0, 0, 1>
    angle 67  
    look_at<xCam-sin(2*pi*clock),yCam-.25,zCam+cos(2*pi*clock)>
    //rotate<0,0,0>    
  } 
  
global_settings{
  //ambient_light <1,1,1>
  assumed_gamma 2.2
  //adc_bailout 1/255
  max_trace_level 8
  }                                                
  
light_source{1e100*y 
  color rgb<min(1,.9+.5*clock),min(1,1.1-.5*clock),min(.8,.9-.5*clock)>
  rotate<60.98+20*clock,-46+10*clock,0>}
sky_sphere{
  pigment{
    gradient y color_map{
     [0 rgb<0,0,.5>]
     [.3 rgb<0,0,1>]
     [.5 rgb<0,.3+.4*clock,1>]
     [.99983 rgb<min(.3+1.4*clock,1),min(.8+.4*clock,1.2-.4*clock),min(1,1.4-.8*clock)>] 
     [.99983 rgb<min(1,.9+.5*clock),min(1,1.1-.5*clock),min(.8,.9-.5*clock)>]
    }
    translate -.5*y scale 2  rotate<60.98+20*clock,-46+10*clock,0>
  }
}

height_field{png   "Larud.png"
//  inverse | texture {...}
  smooth        // make smoother surface
//  [water_level N] // truncate/clip below N (0.0 ... 1.0)
  translate<-.5,0,-.5> scale<800,100,800>// rotate<-90,0,0>
  pigment{rgb<.8,.3,0>}
} 
                  
/*julia_fractal {
  <-0.083,0.0,-0.83,-0.025>
  quaternion
  sqr
  max_iteration 8
  precision 15
  pigment{rgb<1,0,0>
  }
 }*/         
 
plane{y, 50    
  hollow
  pigment{rgbf<.8,.9,1,1>}
  normal{waves phase -10*clock translate<0,50,0> scale 10}
  finish{   
    diffuse .2 
    specular .8 roughness .001
    reflection .8
  }                 
  interior{
    ior 1.33
    media {
    absorption<.1,.03,.001>
    scattering{4 <.001,.03,.1>}
    }
  }
}          

plane{y,-200
   pigment{rgb<.8,.3,0>}
 }