// Arquivo principal de cena para o traador de raios de Persistence of Vision
// Arquivo: Letras ao chou.pov
// Vers: 3.6
// Descri: Apresenta uma letra do alfabeto ao chou.
// Data de cria: 16-IX-2005
// Data da ltima actualiza: _
// Autor: Xos B. Carballeira Rabual

#version 3.6;


//----------------------------------------------- OPES --------------------------------------------------

// Alfabeto espanhol, maisculas
#declare Alfabeto=array[27]{"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "\u0084", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"}

#declare ProbVogal=1/3;
#declare Probabilidades=array[27]

#declare Conta=0;
#while(Conta<27)
  #if((Conta=0)|(Conta=4)|(Conta=8)|(Conta=15)|(Conta=21))
    #declare Probabilidades[Conta]=ProbVogal/5;
  #else
    #declare Probabilidades[Conta]=(1-ProbVogal)/22;
  #end
  #declare Conta=Conta+1;
#end

//------------------------------------------------ CENA ---------------------------------------------------

global_settings{
  assumed_gamma 1
}

camera{
  location -4*z
  right x
  up y
  direction 3*z
  look_at 0
}

light_source{1e7*y rgb 1 rotate<-64.76,45,0>}

#declare Jun=seed(87);

#declare Kak=0;
#while(Kak<frame_number)
  #declare Seme=rand(Jun);
  #declare Kak=Kak+1;
#end

#declare Compt=0;
#declare Conta=-1;
#while(Compt<=Seme)
  #declare Compt=Compt+Probabilidades[Conta+1];
  #declare Conta=Conta+1;
#end


#declare Letra=text{ttf "crystal.ttf", Alfabeto[Conta], 2, 0}

object{Letra translate -(max_extent(Letra)+min_extent(Letra))/2 pigment{rgb 1}}
