// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Letreiro para os cristais de sal.pov
// Vers: 3.5
// Descri: Letreiro para pr no vaso que deixei no faiado da casa com auga salgada: quero que
    //vaiam medrando os cristais durante o novo curso. Rela de aspecto: 10/3
// Data: 14-IX-2002
// Autor: Xos B. Carballeira Rabual


#version 3.5;


camera{
  location<-5,24,-400>
  right 100*x up 30*y direction 400*z
  look_at 0
}

global_settings{
  assumed_gamma 1
  max_trace_level 50
}

background{rgb<.6,.8,.95>}

light_source{1000*y rgb 1 parallel point_at 0 rotate<-40,-20,0>}

text {
  ttf "elephnt.ttf", "Cristales de sal com\u009Cn en formaci\u0097n", 2, <.03,0,0>
  texture{
    pigment{
      crackle colour_map{
        [0 rgb<.8,.6,.1>]
        [.3 rgb<.4,.9,.3>]
        [.6 rgb<.3,.9,.5>]
        [.6 rgb<.1,.2,.1>]
        [1 rgb<.3,.2,.1>]
      }
      warp{turbulence .3}
    }
    normal{granite}
    finish{
      diffuse .6 brilliance 2
      specular .2 roughness .2
    }
  }
  scale 5 translate<-47,10,0>
}
text {
  ttf "elephnt.ttf", "Se ruega no tocar", 4, <.03,0,0>
  texture{
    pigment{
      crackle colour_map{
        [0 rgb<.8,.4,.1>]
        [.2 rgb<.5,.04,.01>]
        [.3 rgb<.3,.1,.02>]
        [.4 rgb<.4,.05,.1>]
        [.6 rgb<.7,.15,.1>]
        [1 rgb<.5,.1,.2>]
      }
      warp{turbulence .4}
    }
    normal{granite}
    finish{
      diffuse .85 brilliance 3
      specular .3 roughness .1
    }
  }
  scale 6 translate<-25,4,-4>
}

#declare Cristal=box{-1,1}
merge{
  #declare ContaCristais=0;
  #declare Yuaig=seed(1);
  #while(ContaCristais<20)
    object{Cristal scale <rand(Yuaig),rand(Yuaig),rand(Yuaig)>*5.5+.5
      rotate<rand(Yuaig),rand(Yuaig),0>*360
      translate<(rand(Yuaig)-.5)*100,(rand(Yuaig)-.5)*15-5,(rand(Yuaig)-.5)*50+10>
    }
    #declare ContaCristais=ContaCristais+1;
  #end
  texture{
    pigment{rgbf 1 quick_color rgb<1,1,0>}
    finish{
      diffuse .2 brilliance 3
      specular .7 roughness .005
      reflection{.2, .5 fresnel}
      conserve_energy
    }
  }
  interior{ior 1.544 dispersion 1.012 caustics .8}
}

plane{y, 30 //Auga
  pigment{rgbf<.9,.98,.99,1>}
  normal{ripples scale 3}
  finish{
    diffuse .1
    specular .5 roughness .001
    reflection{.1,.7 falloff 3 fresnel}
    conserve_energy
  }
  interior{
    ior 1.33 dispersion 1.007 caustics .9
    fade_distance 5000 fade_power 1024 fade_color rgb<.01,.05,.1>
  }
}