// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Materiais varios.inc
// Vers: 3.6
// Descri: Materiais diversos. A unidade de longitude  o metro.
// Data de cria: 4-VI-2003; procede do velho Os nosos materiais.inc, criado o 28-IV-2002.
// Data da ltima actualiza: 27-VII-2004 (actualizei-o para a vers 3.6)
// Autor: Xos B. Carballeira Rabual


#local versionMateriais=version;
#version 3.6;

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Materiais varios.inc\", que define varias texturas e materiais.\n"
#end

//=============================================== PLSTICOS ========================================================


//================================================= VRIOS =========================================================

#declare PinturaRoxa=texture{ //Daquela cor que tanto nos prestara nas prticas do POV-Ray
  pigment{rgb<1,.34,.1>}
  finish{
    brilliance 3
    specular .8 roughness .001 metallic
  }
}

#declare PinturaVermelha=texture{ //Pintura semelhante  das farolas do Passeio Martimo crunhs
  pigment{rgb<.9,.04,.03>}
  finish{
    brilliance 6
    specular .8 roughness .001 metallic
  }
}

#declare Cera=texture{
  pigment{rgb<.9,.95,.7>}
  normal{bumps .2 scale .001}
  finish{diffuse .7 brilliance 2 specular 1 roughness .05}
}

#declare TeiaNegraSintetica=texture{
  pigment{rgb<.1,.07,.08>}
  normal{            //Imita os fios cruzados perpendicularmente.
    gradient x
    normal_map{
      [0 gradient y scallop_wave frequency 10 bump_size 1]
      [1 gradient y slope_map{[.5 <0,0>]}]
    }
    scallop_wave
    scale .005
  }
  finish{
    specular .8 roughness .01
  }
}

#declare PapelBranco=texture{
  pigment{rgb<.95,.97,.93>}
  normal{granite .3 scale .02}
  finish{diffuse .9 specular.05 roughness .5}
}


#version versionMateriais;