// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Orbitas.pov
// Vers: 3.5
// Descri: Corpos varios interactuando
// Data de cria: 17-VIII-2003
// Data da ultima actualiza: _
// Autor: Xos B. Carballeira Rabual

#version 3.5;


//-------------------------------------------- Opes ----------------------------------------------------

#declare QueCamara=0;  //Perspectiva desde o espao exterior
//#declare QueCamara=1;  //Olho de peixe a repousar no cho do planeta
//#declare QueCamara=2;  //Perspectiva na direc e sentido do movimento do satlite respeito do centro
                             //de massas conjunto dos trs corpos, desde o ponto ajeitado da sua superfcie


//-------------------------------------------- Cena -----------------------------------------------------

#include "Matematica.inc"
#include "Mecanica.inc"

global_settings{
  assumed_gamma 1
  ambient_light .1
}

#declare Tempuxe=1000*clock;

#sky_sphere{
  pigment{
    granite colour_map{
      [.85 rgb 0]
      [.86 rgb<1,0,0>]
      [.91 rgb<1,1,0>]
      [.96 rgb 1]
      [1 rgb<0,1,1>]
    }
    scale .02 translate .0001*Tempuxe
  }
}

#declare Inercias=array[3][3][7]
InerciaEsfera(3, 1, Inercias, 0, 0)
InerciaCono(1, .4, .4, y, Inercias, 0, 1)
InerciaCilindro(1, .2, .4, z, Inercias, 0, 2)
InerciaEsfera(1, .5, Inercias, 1, 0)
InerciaCono(.3, .2, .2, y, Inercias, 1, 1)
InerciaCilindro(.3, .1, .2, x, Inercias, 1, 2)
InerciaEsfera(.1, .2, Inercias, 2, 0)

#macro MecXos_Forcas(CorpoActual, ElementoActual, Resultante, Momento)
  #declare Resultante=<0,0,0>;
  #local ContaCorpos=0;
  #while(ContaCorpos<QuantosCorpos)
    #if(ContaCorpos!=CorpoActual)
      #local ContaElmts=0;
      #while(ContaElmts<QuantosElementos[ContaCorpos])
          #local Veitor =
            MecXos_Posicoes[ContaCorpos][ContaElmts]-MecXos_Posicoes[CorpoActual][ElementoActual];
          #declare Resultante=Resultante +
            Inercias0[ContaCorpos][ContaElmts][0]*Inercias0[CorpoActual][ElementoActual][0]*Veitor /
            pow(vlength(Veitor),3);
        #declare ContaElmts=ContaElmts+1;
      #end
    #end
    #declare ContaCorpos=ContaCorpos+1;
  #end
#end

MovSolRigCampoDeForcas("Orbitas", array[3]{3, 3, 1}, 1000,
  array[3][3]{{<0,0,0>, <0,1,0>, <0,0,1>}{<5,0,0>, <5,.5,0>, <5.5,0,0>}{<6.5,0,0>, <0,0,0>, <0,0,0>}},
  Inercias, array[3]{-.32*y, 1*y, <0,0,0>}, array[3]{<0,0,.2>, <.1,.1,.6>, <0,0,0>}, Tempuxe, 0
)

union{
  sphere{0, 1 texture{pigment{rgb<1,1,0>} finish{diffuse 0 ambient 10}}}
  cone{.9*y, .4, 1.3*y, 0 texture{pigment{rgb<1,0,0>} finish{diffuse 0 ambient 10}}}
  cylinder{.8*z, 1.2*z, .2 texture{pigment{rgb<0,1,0>} finish{diffuse 0 ambient 10}}}
  light_source{0 rgb 1 fade_power 2 fade_distance 7}
  no_shadow
  transform MecXos_Movimentos[0]
}

union{
  sphere{5*x, .5 pigment{rgb<0,1,1>}}
  cone{<5,.45,0>, .2, <5,.65,0>, 0 pigment{rgb<1,0,1>}}
  cylinder{5.4*x, 5.6*x, .1 pigment{rgb<0,0,1>}}
  transform MecXos_Movimentos[1]
}

sphere{6.5*x, .2 pigment{rgb 1} normal{bumps scale .02} transform MecXos_Movimentos[2]}


#switch(QueCamara)
  #case(0)
    #declare ContaCorpos=0;
    #declare MiraPrAli=<0,0,0>;
    #while(ContaCorpos<3)
      #declare MiraPrAli=MiraPrAli+MecXos_CMs[ContaCorpos]*Masa(ContaCorpos)/6.7;
      #declare ContaCorpos=ContaCorpos+1;
    #end
    #declare ContaCorpos=0;
    #declare MaxDist=0;
    #while(ContaCorpos<3)
      #declare MaxDist=max(vlength(MecXos_CMs[ContaCorpos]-MiraPrAli),MaxDist);
      #declare ContaCorpos=ContaCorpos+1;
    #end
    #if(Tempuxe=0)
      #declare OndeMePonho=MiraPrAli+8*MaxDist*z;
    #else
      #fopen Guad concat(Xose_PastaTemp, "\\Ponto de vista.xose") read
        #read(Guad, OndeMePonho)
      #fclose Guad
      #declare OndeMePonho=.8*OndeMePonho+.2*(MiraPrAli+10*MaxDist*z);
    #end
    #fopen Guad concat(Xose_PastaTemp, "\\Ponto de vista.xose") write
      #write(Guad, NotacionCientificaVector(3,OndeMePonho,17))
    #fclose Guad
    camera{
      location OndeMePonho
      right x
      up y
      direction -3*z
      sky y
      look_at MiraPrAli
    }
  #break
  #case(1)
    #declare CaraAlo=vrotate(.5001*x,<0,-30,20>);
    camera{
      fisheye
      location 5*x+CaraAlo
      right x
      up y
      direction -z
      sky z
      angle 190
      look_at 5*x+2*CaraAlo
      transform MecXos_Movimentos[1]
    }
  #break
  #case(2)
    #declare CaraOnde=MecXos_VelocidadesCM[2];
    #declare ContaCorpos=0;
    #while(ContaCorpos<3)
      #declare CaraOnde=CaraOnde-MecXos_VelocidadesCM[ContaCorpos]*Masa(ContaCorpos)/6.7;
      #declare ContaCorpos=ContaCorpos+1;
    #end
    #if(vlength(CaraOnde)=0)
      #declare CaraOnde=-x;
    #else
      #declare CaraOnde=vnormalize(CaraOnde);
    #end
    camera{
      location 6.5*x+.2001*CaraOnde
      right x
      up y
      direction -3*z
      sky z
      look_at 6.5*x+CaraOnde
      transform MecXos_Movimentos[2]
    }
#end