// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Polo espaco.pov
// Vers: 3.5
// Descri: Umha volta por a arriba.
// Data: 27-X-2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

//#include "colors.inc"
//#include "woods.inc"
#include "Materiais varios.inc"
#include "bmpeople.inc"
#include "Texturas humanas.inc"

global_settings{
  assumed_gamma 1
  max_trace_level 25
}

camera{
  //spherical
  //orthographic
  //location <-.6,1.4,-1.7>  //Interior da cabina
  //location <-.1,.9,1.85>  //Umbigo da piloto e arredores
  //location <-1,2,3>  //Exterior, prxima ao assento do piloto
  //location<0,1.2,1.26>  //Onda o volante
  //location<1,.4,1>  //Pedais
  //location<.1,.2,2>  //Ps da piloto
  //location<0,5,-8>  //Prxima  cabina, por detrs
  //location<4,5,-13>  //Posterior
  //location<0,5,13>  //Frontal
  //location 30*y  //Superior
  location<8,12,24> //Geral
  //location<20,12,0>  //Estribor
  right 4/3*x
  up y
  direction 3*z
  //look_at<0,0,0>
  //look_at<0,1.2,-1.3>  angle 70//Interior
  look_at<0,1,1.5>  //Xeral
  //look_at <0,.87,1.32> angle 70  //Umbigo da piloto
  //look_at<0,.85,1.8> angle 70  //Onda o volante
  //look_at<0,.3,1.8> angle 50  //Pedais
  //look_at<0,.1,1.4> angle 70  //Ps da piloto
  //angle 360
}

//Fundo estrelado
sky_sphere{
  pigment{
    granite colour_map{
      [.85 rgb 0]
      [.85 rgb<1,0,0>]
      [.88 rgb<1,1,0>]
      [.93 rgb<1,1,1>]
      [.98 rgb<0,1,1>]
      [1 rgb<0,0,1>]
    }
    
    scale .01
  }
}

light_source{<30,60,30> rgb 1
  //shadowless
}
//light_source{<0,.8,1.1> rgb<.8,.2,.2>}
//light_source{<0,1.4,.5> rgb<.2,.8,.8>}


//----------------------------------------- Pratinho volante ----------------------------------------------------

//Coiro escuro e rugoso
#local Coiro = texture{
  pigment{rgb<.06,.08,.1> }
  finish{
    diffuse 0.6
    specular 0.6
    roughness 0.1
  }
  normal{crackle .6 scale 0.1}
}

#declare PlasticoDuroNegro=texture{
  pigment{rgb <.06,.08,.07>}
  finish{
    diffuse 0.7
    brilliance 3
    specular 0.6
    roughness 0.1
  }
}

#declare PlasticoRugosoNegro=texture{
  pigment{rgb <.17,.15,.13>}
  normal{dents 6 warp{turbulence 0.5} scale 0.0001}
  finish{
    diffuse 0.6
    specular 0.7
    roughness 0.11
  }
}

#declare Laton=texture{
  pigment{rgb<.9,.8,.1>}
  finish{
    ambient .1
    diffuse .7 brilliance 6
    specular .7 roughness .005 metallic
    reflection{.2 metallic}
  }
}

#declare Vidro=material{
  texture{
    pigment{rgbf 1}
    finish{
      specular .9 roughness .0005
      reflection{.1}
    }
  }
  interior{
    ior 1.5
    dispersion 1.01
  }
}

#local Assento=union{
  union{               //Parte inferior
    superellipsoid{        //Coxim
      <.1,.3> scale<.25,.062,.2> translate<0,.06,.01>
      texture{
        Coiro
        pigment{quick_color rgb<0,1,0>}
      }
    }
    superellipsoid{        //Reforo
      <.1,1> scale<.2*25/24,.003,.15> translate<0,-.0001,.01>
      texture{
        PlasticoDuroNegro
        pigment{quick_color rgb<1,0,1>}
      }
    }
  }
  union{               //Respaldo
    superellipsoid{        //Coxim
      <.1,.1> rotate<5,0,0> scale<.25,.265,.061> rotate<-6,0,0> translate<0,.263,-.26>
      texture{
        Coiro
        pigment{quick_color rgb<1,0,0>}
      }
    }
    superellipsoid{        //Reforo com o cartaz Bruja Piruja
      <.1,.5> scale<.2*25/24,.16,.003>
      texture{
        finish{
          diffuse 0.7
          brilliance 2
          specular 0.3
          roughness 0.1
        }
        pigment{
          image_map{
            jpeg "Bruja Piruja.jpg"
            once
            map_type 0
            interpolate 2
          }
          translate<-.5,0,0>
          scale <.31,.24,.001>
          translate<0,-.12,0>
          quick_color rgb<0,1,1>
        }
      }
      translate<0,0,-48.5>/1000 rotate<-4.85,0,0> translate<0,.263,-.2701>
    }
    translate<0,.005,0>
  }
  cylinder{0, -.49*y, .2 texture{Coiro pigment{rgb<.04,.2,.5>}}}
  translate .48*y
}

#declare PratinhoVolante=union{

  //Cpula
  difference{
    sphere{0, 2.7}
    sphere{0, 2.5 interior{ior 1.000292}
      //pigment{rgb 1}  //Ajuda a provar se algum objecto interior atravessa a cpula.
    }
    plane{y, -.0001}
    bounded_by{box{<-2.701, -.001, -2.701>, <2.701, 2.701, 2.701>}}
    material{Vidro}
  }

  //Corpo e habitculo
  difference{
    sphere{0, 5 scale<1,1/5,1>}
    intersection{
      sphere{0, 2.495}
      plane{-y, 0}
      texture{Coiro pigment{rgb<.03,.67,.355>}}
    }
    texture{
      pigment{uv_mapping
        object{
          text{ttf "bookosbi.ttf", "Xoselander I", 2, <0,0,0>
            translate -z scale<.02,.07,1> translate<.185,.6,0>
          }
          rgb<.85,.89,.97>, rgb<.01,.05,.3>
        }
      }
      normal{bozo .1 scale .3}
      finish{
        diffuse .8 brilliance 3
        specular .8 roughness .001 metallic
      }
    }
  }

  //Propulsores
  #local Propulsor=difference{
    sphere{0, 1 scale<.5,.5,2>}
    sphere{0, 1 scale<.4,.4,1.8>}
    plane{z, -.05}
    texture{PinturaVermelha}
  }
  #local ParelhaDePropulsores=union{
    object{Propulsor translate<-.5,0,-1>}
    object{Propulsor translate<.5,0,-1>}
  }
  object{ParelhaDePropulsores translate<0,1,-3.7>}
  object{ParelhaDePropulsores rotate -12*z rotate 72*y translate<0,1.015,-3.7> rotate -72*y}
  object{ParelhaDePropulsores rotate 12*z rotate -72*y translate<0,1.015,-3.7> rotate 72*y}
  object{ParelhaDePropulsores rotate 7.1*z rotate -36*y translate<0,1,-3.7> rotate -144*y}
  object{ParelhaDePropulsores rotate -7.1*z rotate 36*y translate<0,1,-3.7> rotate 144*y}

  //Assentos
  object{Assento translate<-1.2364,0,.4017>}
  object{Assento translate<1.2364,0,.4017>}
  object{Assento translate<-.7641,0,-1.0517>}
  object{Assento translate<.7641,0,-1.0517>}
  object{Assento translate<0,0,1.3>}

  //Petouto de mandos
  superellipsoid{<.5,.5> scale<1,.6,.2> translate<0,.4,2.05> texture{Coiro pigment{rgb<.96,.22,.05>}}}

  //Volante
  union{
    torus{.22, .02 texture{PlasticoRugosoNegro}}
    cylinder{0, .22*z, .01}
    cylinder{0, .22*z, .01 rotate 120*y}
    cylinder{0, .22*z, .01 rotate 240*y}
    superellipsoid{<1,.3> rotate 90*x scale<.02,.25,.02> translate -.22*y texture{Laton}}
    texture{PinturaVermelha}
    rotate -60*x translate<0,1,1.6>
  }

}

object{PratinhoVolante}


//---------------------------------------- Personagens --------------------------------------------------------

//A Pseudo-Lara Croft
#include "bm_hands.inc"
#include "bm_hair.inc"
#declare BM_Pose=array[1][17]{{
  <0,0,0>, <5,0,0>, <-5,0,0>, <0,0,-15>, <60,0,-15>, <0,0,15>, <60,0,15>, <80,45,0>, <10,0,100>,
  <80,-45,0>, <-8,0,-104>, <-30,0,0>, <-30,0,0>, <0,0,0>, <0,100,-20>, <0,-100,20>, <11,0,11>
}}
#declare BM_PoseNo=0;
#include "croft.cdf"
BM_CorDaPele(PelMorena)
#declare BM_HairStyle=0;  //Activando esta instru, suprime-se o cabelo, e isso acelera as provas.
Blob_Man(Female, 1.75)
object{BlobMan
  //transform BMO_Foot_R
  transform BMO_Abdomen_U
  rotate 180*y
  //translate<-1,0,.6>
}

//O explorador
#include "bm_pose.inc"
#declare BM_PoseNo=0;
#declare BM_HairCol=PeloCastanhoEscuro;
#declare BM_EyeCol=OlhosNegros;
BM_CorDaPele(PeleRoxa)
#declare BM_Foot_R_Object=object{BM_Foot_R_Object scale 1.1}
#declare BM_Foot_L_Object=object{BM_Foot_L_Object scale 1.1}
#declare BM_Calf_R_Object=object{BM_Calf_R_Object scale 1.1}
#declare BM_Calf_L_Object=object{BM_Calf_L_Object scale 1.1}
#declare BM_Abdomen_Object=object{BM_Abdomen_Object translate 4*y scale 1.2}
#declare BM_Torso_Object=object{BM_Torso_Object translate<0,.9,-.8> scale 1.2}
#declare BM_Flex=on;
//#declare BM_HairStyle=1; //Cabelo; podem-se agilizar as provas desactivando-o.
#declare BM_HairStyle=0;  //Activando esta instru, suprime-se o cabelo, e isso acelera as provas.
Blob_Man(Male, 1.8)
object{BlobMan
  transform BMO_Foot_R
  rotate 170*y
  translate<1,0,1>
}

#include "Apaga tudo.cdf"

//A piloto
#declare BM_Pose=array[1][17]{{
  <0,0,0>, <0,0,0>, <0,0,0>, <25,0,-20>, <105,2,0>, <25,0,20>, <110,2,0>, <90,15,0>, <0,0,0>,
  <90,-15,0>, <0,0,0>, <-50,0,0>, <-50,0,0>, <50,0,50>, <0,-10,0>, <0,20,0>, <0,0,0>
}}
#declare BM_PoseNo=0;
#declare BM_HairCol=PeloCastanhoClaro;
#declare BM_EyeCol=OlhosVerdes;
BM_CorDaPele(PelBranca)
//#declare BM_HairStyle=1; //Cabelo; podem-se agilizar as provas desactivando-o.
#include "Tufgirlz.cdf"
TufGirlz_Costume(1,1,3,0)
Blob_Man(Female, 1.7)
object{BlobMan transform BMO_Abdomen_B rotate 180*y translate<0,.68,1.12>}

#include "Apaga tudo.cdf"

//As astronautas
#include "bm_pose.inc"
#declare BM_PoseNo=9;
#include "sample.cdf"
//#declare BM_HairStyle=1; //Cabelo; podem-se agilizar as provas desactivando-o.
#declare BM_HairCol=PeloCastanhoEscuro;
#declare BM_EyeCol=OlhosMarroes;
BM_CorDaPele(PeleBranca)
Blob_Man(Female, 1.72)
object{BlobMan transform BMO_Torso_F rotate<-10,20,0> translate<4,3,8>}
#declare BM_HairCol=PeloLoiroDouradoCobrico;
#declare BM_EyeCol=OlhosAzuis;
BM_CorDaPele(PeleBranca)
Blob_Man(Female, 1.67)
object{BlobMan transform BMO_Torso_F rotate<-30,-5,0> translate<-2,4,7>}