// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Prova da estereoscopia.pov
// Vers: 3.5
// Descri: Arquivo para provar a cria de parelhas estereoscpicas
// Data: 1-XI-2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

global_settings{
  assumed_gamma 1
}


//================================= DEFINI DA CMARA ==================================================

//#declare Xose_SRDextrogiro=true;  //Quando o sistema de referncia for dextrgiro, active-se isto
                                  //para indic-lo.

#declare Estereoscopia_Olho=0;         //-1 = olho esquerdo, 0 = olho central, 1 = olho direito
#declare Estereoscopia_DistOlhos=1;  //Distncia entre os olhos esquerdo e direito

#declare Estereoscopia_TipoDeCamera=0;   //Projec cnica (perspectiva), a predeterminada
//#declare Estereoscopia_TipoDeCamera=1;   //Projec ortogonal
//#declare Estereoscopia_TipoDeCamera=2;   //Olho de peixe (esfrica polar)
//#declare Estereoscopia_TipoDeCamera=3;   //Gram angular
//#declare Estereoscopia_TipoDeCamera=4;   //Omnimax
//#declare Estereoscopia_TipoDeCamera=5;   //Panormica
//#declare Estereoscopia_TipoDeCamera=6;   //Cilindro vertical, ponto de vista fixo
//#declare Estereoscopia_TipoDeCamera=7;   //Cilindro horizontal, ponto de vista fixo
//#declare Estereoscopia_TipoDeCamera=8;   //Cilindro vertical, ponto de vista mvel
//#declare Estereoscopia_TipoDeCamera=9;   //Cilindro horizontal, ponto de vista mvel
//#declare Estereoscopia_TipoDeCamera=10;  //Esfrica cartesiana

#declare Estereoscopia_UbiCamera=<-.5,1,-12>;  //Ubica da cmara
#declare Estereoscopia_Largo=4/3*x;   //Vector que vai horizontalmente do extremo esquerdo ao direito do quadro,
                                    //antes de girar a cmara
#declare Estereoscopia_Alto=y;      //Vector que vai verticalmente do extremo inferior ao superior do quadro,
                                    //antes de girar a cmara
//#declare Estereoscopia_Focal=3*z;       //Vector que vai do ponto de vista ao centro do quadro, antes de girar a
                                    //cmara
//#declare Estereoscopia_CeuCamera=y;   //Vector arredor do que gira a cmara para apontar ao motivo; ficar sem-
                                    //pre cara arriba na imagem
//#declare Estereoscopia_AngCamera=25;  //ngulo da cmara
//#declare Estereoscopia_AngCamera2=<180,90>;  //ngulos horizontal e vertical da cmara esfrica cartesiana
//#declare Estereoscopia_OlhaCara=<0,0,5>;  //Motivo, ponto que quedar no centro da imagem

//#declare Estereoscopia_TransformaCamera=transform{rotate<-5,-40,0> translate<8,.5,-7>}  //Transforma que se impor  cmara
                                                              //sobre todas as opes anteriores

#include "Estereoscopia.inc"


//========================================== RESTO DA CENA =================================================

background{rgb<.01,0,.05>}

light_source{<-30,20,-30> rgb 1}

plane{y,0 pigment{hexagon}}

union{
  sphere{0, .1 pigment{rgb<.5,.5,.5>}}
  cylinder{-1e7*x,1e7*x,.05 pigment{function{(tanh(x/10)+1)/2} colour_map{[0 rgb 0][.5 rgb<1,0,0>][1 rgb 1]}}}
  cylinder{-1e7*y,1e7*y,.05 pigment{function{(tanh(y/10)+1)/2} colour_map{[0 rgb 0][.5 rgb<0,1,0>][1 rgb 1]}}}
  cylinder{-1e7*z,1e7*z,.05 pigment{function{(tanh(z/10)+1)/2} colour_map{[0 rgb 0][.5 rgb<0,0,1>][1 rgb 1]}}}
}

#if(Xose_SRDextrogiro)
  #local Orientaco="DEXTR"
#else
  #local Orientaco="LEV"
#end
#debug concat("\n    O sistema de referencia e ", Orientaco, "OGIRO.\n")