// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Prova do relevo.pov
// Vers: 3.5
// Descri: Arquivo para fazer provas sobre cenas que se deseje traar em relevo usando o Relevo.inc
// Data: 31-X-2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

global_settings{
  hf_gray_16  //Para criar imagens de 2^16 grisses, quando o tipo de arquivo de sada  ajeitado
}


//================================= DEFINI DA CMARA ==================================================

//#declare Xose_SRDextrogiro=true;  //Quando o sistema de referencia seja dextrgiro, active-se isto
                                  //para indic-lo.

#declare Relevo_TipoDeCamera=0;   //Projec cnica (perspectiva), a predeterminada
//#declare Relevo_TipoDeCamera=1;   //Projec ortogonal
//#declare Relevo_TipoDeCamera=2;   //Olho de peixe (esfrica polar)
//#declare Relevo_TipoDeCamera=3;   //Gram angular
//#declare Relevo_TipoDeCamera=4;   //Omnimax
//#declare Relevo_TipoDeCamera=5;   //Panormica
//#declare Relevo_TipoDeCamera=6;   //Cilindro vertical, ponto de vista fixo
//#declare Relevo_TipoDeCamera=7;   //Cilindro horizontal, ponto de vista fixo
//#declare Relevo_TipoDeCamera=8;   //Cilindro vertical, ponto de vista mvel
//#declare Relevo_TipoDeCamera=9;   //Cilindro horizontal, ponto de vista mvel
//#declare Relevo_TipoDeCamera=10;  //Esfrica cartesiana

#declare Relevo_UbiCamera=<-.2,1.6,-8>;  //Ubicacin da cmara
#declare Relevo_Largo=4/3*x;   //Vector que vai horizontalmente do extremo esquerdo ao direito do quadro,
                                    //antes de girar a cmara
#declare Relevo_Alto=y;      //Vector que vai verticalmente do extremo inferior ao superior do quadro,
                                    //antes de girar a cmara
#declare Relevo_Focal=3*z;       //Vector que vai do ponto de vista ao centro do quadro, antes de girar a
                                    //cmara
#declare Relevo_CeuCamera=y;   //Vector arredor do que gira a cmara para apontar ao motivo; ficar sem-
                                    //pre cara arriba na imagem
//#declare Relevo_AngCamera=360;  //ngulo da cmara
//#declare Relevo_AngCamera2=<180,90>;  //ngulos horizontal e vertical da cmara esfrica cartesiana
#declare Relevo_OlhaCara=<0,.8,0>;  //Motivo, ponto que quedar no centro da imagem

//#declare Relevo_MaxRel=.8;
//#declare Relevo_MinRel=.65;
#declare Relevo_MaxFond=5.3;
#declare Relevo_MinFond=4.8;

//#declare Relevo_ExponentePerto=1;
//#declare Relevo_ExponenteLonge=1;
//#declare Relevo_FactorPerto=1;
//#declare Relevo_FactorLonge=1;

#include "Relevo.inc"


//======================================== OBJECTOS DA CENA =================================================

//Os objectos devem ter a textura Relevo_Tex, ou bem carecer de textura.

plane{y, 0}

#include "bmpeople.inc"
#include "bm_pose.inc"
#declare BM_PoseNo=0;
#declare Xose_SemTexturas=true;
//#include "Sem texturas.cdf"
Blob_Man(Male, 1.8)
object{BlobMan transform BMO_Foot_R translate -.5*x}
#include "croft.cdf"
#declare BM_HairStyle=0;
Blob_Man(Female, 1.8)
object{BlobMan transform BMO_Foot_L rotate 60*y translate 0*x-4*z}

//sphere{<-.5,0,0>, .4}
//sphere{<.5,0,0>, .4 translate -2*z}

#if(Xose_SRDextrogiro)
  #local Orientaco="DEXTR"
#else
  #local Orientaco="LEV"
#end
#debug concat("\n    O sistema de referencia e ", Orientaco, "OGIRO.\n")