// Arquivo principal de cena para o traador de raios de Persistence of Vision
// Arquivo: Provas gerais.pov
// Vers: 3.6
// Descri: Arquivo para fazer toda classe de provas
// Data de cria: 27-X-2002
// Data da ltima actualiza: 8-VIII-2004 (adaptei-o  vers 3.6)
// Autor: Xos B. Carballeira Rabual

#version 3.6;

//----------------------------------- Referncias a outros arquivos ----------------------------------------------

//#include "Corpos lineares.inc"
//#include "Caixa animavel.inc"
#include "Fogar.inc"
#include "Figuras geometricas.inc"


//----------------------------------------- Opes globais ----------------------------------------------------------

global_settings{

  //Cores no arquivo de sada
  assumed_gamma 1
  //hf_gray_16

  //Jogo de caracteres
  charset ascii   //Cdigo ASCII universal: s os caracteres do 0 ao 127
  //charset utf8  //Unicode
  //charset sys   //Jogo de caracteres prprio do sistema

  //Raios traados
  adc_bailout 1/255  //Umbral do ADC [1/255]
  max_trace_level 25  //[5]
  max_intersections 64  //[64]

  //Luz
  ambient_light rgb<1,1,1>
  /*radiosity{
    pretrace_start 0.08   //Tamanho inicial dos blocos no pretrao, em frac do largo da imagem [0.08]
    pretrace_end   0.04   //d. final [0.04]
    count 30              //N. de raios adicionais lanados cada vez (1, ..., 1600) [35]
    nearest_count 5       //N. mnimo de mostras promediadas para cada ponto (1, ..., 10) [5]
    error_bound 1       //Erro mximo estimado para cada ponto [1.8]
    recursion_limit 2     //Mximo nvel de interreflex computado (1, ..., 20) [3]
    low_error_factor .5   //Factor de redu do umbral de erro durante o pretrao [0.5]
    gray_threshold 0    //Frac de gris que se aplicar s cores da interreflex (0 ... 1) [0]
    minimum_reuse .02   //Mnimo raio de reutiliza das mostras, en frac da distncia desde o
                              //ponto de vista [0.015]
    brightness 1          //Brilho da interreflex [1]
    adc_bailout 0.01      //Umbral do ADC para os raios da interreflex [0.01]
    //normal on                   //Considera-se o influxo das normais perturbadas? [off]
    //media on                    //Considera-se a ac do meio? [off]
    //save_file "file_name"       //Guardam-se num arquivo os dados da interreflex?
    //load_file "file_name"       //Recolhem-se dum arquivo os dados da interreflex?
    //always_sample off           //Tomam-se mostras durante o trao final? [on]
    //max_sample 1.0              //Mximo brilho das mostras (0 = sem limite) [0]
  }*/
  irid_wavelength <0.25, 0.18, 0.14> //[<0.25, 0.18, 0.14>]
  /*photons{  //Precisa tambm ajuste para cada objecto ou fonte de luz.
    spacing .01                 //Distncia mdia entre ftons
    //count 100000               //Alternativa: nmero total aproximado de ftons
    //gather min, max            //Nmeros mnimo e mximo de ftons recolheitos em cada ponto [20, 100]
    //media max_steps [,factor]  //Ftons nos media: n. mx. por intervalo e, opcionalmente, factor de
                                     //aumento da distncia mdia respeito dos ftons nas superfcies
    //jitter 1.0                 //Tremor dos raios fotnicos
    //max_trace_level 5          //Mximo nvel de trao para os ftons
    //adc_bailout 1/255          //Umbral do ADC para os ftons
    //save_file "filename"       //Guarda-se num arquivo o mapa de ftons?
    //load_file "filename"       //Recolhe-se dum arquivo o mapa de ftons?
    //autostop 0                 //Mnima frac da espiral que se percorrer (0 ... 1)
    //radius 10                  //Raio de procura especificado manualmente
    // (---Adaptive Search Radius---)
    //steps 1  //N sei o que  isto.
    //expand_thresholds 0.2, 40
  }*/

  //Geradores de rudo; podem-se aplicar individualmente a cada patr, dentro do correspondente bloco de
    //instrues.
  //noise_generator 1 //Velho gerador de rudo da vers 3.1g; produzia mesetas.
  noise_generator 2 //Gerador de rudo da vers 3.1, arranjado
  //noise_generator 3   //Novo gerador de rudo de Perlin, da vers 3.5

  //Nmero de ondas nos patres waves e ripples
  number_of_waves 10

}


//-------------------------------------------- Cmara ----------------------------------------------------------

//  Em ambas as duas cmaras seguintes, os vectores right, up e direction escolhrom-se de modo que
//um olho situado na perpendicular mdia da imagem, a uma distncia igual ao triplo da altura desta, ver
//uma perspectiva realista se a rela de aspecto for 4/3.

//Sistema de referncia levgiro
camera{
  //spherical
  //fisheye
  location<.5,1.3,-4>
  right 4/3*x
  up y
  direction 3*z
  sky y
  look_at <0,0,0>
  //look_at <0,1.2,0>
  //angle 360
}
//d. dextrgiro
/*camera{
  location<-.2,-8,1.6>
  right 4/3*x
  up z
  direction 3*y
  sky z
  look_at .6*z
}*/


//--------------------------------------------- Accessrios -----------------------------------------------------

light_source{
  <40,30,-60> rgb 1 media_attenuation on
  //looks_like{sphere{0, 1 double_illuminate pigment{rgb<1,.6,0>}}}
}

#declare RaioOrigem=.02;
#declare RaioEixos=.01;

 //Origem de coordenadas
sphere{0, RaioOrigem pigment{rgbt<1,.5,.5,.7>}}

 //Eixos coordenados
cylinder{-1e7*x, 1e7*x, RaioEixos pigment{rgbt<.5,.5,1,.7>}}
cylinder{-1e7*y, 1e7*y, RaioEixos pigment{rgbt<.5,.5,1,.7>}}
cylinder{-1e7*z, 1e7*z, RaioEixos pigment{rgbt<.5,.5,1,.7>}}

 //Planos coordenados
//plane{x, 0 hollow pigment{rgbt<1,.5,.5,.7>}}
plane{y, 0 hollow pigment{rgbt<.5,1,.5,.7>}}
//plane{z, 0 hollow pigment{rgbt<.5,.5,1,.7>}}


//____________________________________________                __________________________________________________
//____________________________________________ ZONA DE PROVAS __________________________________________________

/*#declare Tempo=10*clock+2.9;

#declare ElongResorte=.001+.5*(sin(pi/2*max(Tempo-3,0)/.3)*exp(-.5*(Tempo-3)));
object{Mesa}
#declare Rebaixo=.4-sqrt(pow(.4,2)-pow(.2,2));
#declare Corpo=difference{
  box{<.25,.15-.01-Rebaixo,.2>, -<.25,.15,.2>}
  box{<.25-.01,.15-Rebaixo,.2-.01>, -<.25,.15,.2>+.01}
}
#declare Tampa=difference{
  cylinder{<.25,.15-.4,0>, <-.25,.15-.4,0>, .4}
  cylinder{<.25-.01,.15-.4,0>, <-.25+.01,.15-.4,0>, .4-sqrt(2)*.01}
  box{<.501*.5,.501*.3-.01-Rebaixo,1.001*.4>, <-.501*.5,.15-2.001*.4,-1.001*.4>}
  bounded_by{box{<.501*.5,.501*.3,.501*.4>, <-.501*.5,.499*.3-.01-Rebaixo,-.501*.4>}}
  #declare Trasl=<0, .15-.01-Rebaixo, .2>;
  translate -Trasl rotate 150*sin(pi/2*min(max(Tempo-3,0)/.5,1))*x translate Trasl
}
union{
  union{
    object{Corpo}
    object{Tampa}
    pigment{rgb<.2,.25,0>}
  }
  object{
    Serpentino(.06,ElongResorte/8,.004,-.15,-.15+ElongResorte,12,.001)
    pigment{rgb<1,0,0>}
  }
  sphere{
    0, 1
    *//*pigment{
      image_map{jpeg "Maria.jpg" once interpolate 2}
      translate -.5 scale 2
    }*/
    /*pigment{rgbf 1}
    normal{bumps .1}
    finish{
      diffuse 0 ambient 0 specular .6 roughness 1/100
      reflection{fresnel}
    }
    interior{ior 1.5}
    scale .13 translate (-.15+1.25*ElongResorte)*y
  }
  translate (.82+.15)*y
}*/


