// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Queda.pov
// Vers: 3.5
// Descri: Queda dumha pelota
// Data: Derradeiro trimestre do ano 2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

//#declare Xose_Mensagens=true;

#include "Matematica.inc"
#include "Mecanica.inc"

global_settings{
  assumed_gamma 1
}

background{rgb<.01,0,.05>}

light_source{<-30,20,-30> rgb 1}

//Cho
plane{y,0 pigment{checker}}

union{cylinder{-6*x, 6*x, .05} cone{5.8*x, .2, 6.3*x, 0} pigment{rgb .5}}
union{cylinder{-6*y, 6*y, .05} cone{5.8*y, .2, 6.3*y, 0} pigment{rgb .5}}
union{cylinder{-6*z, 6*z, .05} cone{5.8*z, .2, 6.3*z, 0} pigment{rgb .5}}

//sphere{0, .2 pigment{rgb<1,0,0>} MUA(<5,7,0>, Gravidade, clock)}
//sphere{0, .3 pigment{rgb<1,0,0>} MUA(<5,7,0>, Gravidade, clock)}
sphere{0, .3
  pigment{
    gradient y colour_map{
      [0 rgb<1,.5,0>]
      [.2 rgb<1,1,0>]
      [.5 rgb<0,1,0>]
      [.7 rgb<0,0,1>]
      [1 rgb<1,0,1>]
    }
  }
  #macro MecXos_Forcas(Inmier, Pos, Vel, VelAng, Tempo, Massa, MassasAgentes, VectsAgentes, Repe, Falty)
    #declare Repe=(Massa*Gravidade);
  #end
  #declare Posicoes0=array[1]{<0,0,0>}
  #declare Inercias=array[1][7]
  InerciaEsfera(1, .3, Inercias, 0)
  MovSolRigCampoDeForcas("Peppo", Posicoes0, Inercias, <5,7,0>, <0,1,.2>, clock, 1)
  transform Movimento
}

camera{
  location<5,1.6,-20>
  right 4/3*x
  up y
  direction 3*z
  angle 10
  look_at MecXos_CM
}
