// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Relevo.inc
// Vers: 3.5
// Descri: Cria grficos da cena, em escala de grisses, nos que a escurid representa a fundura.
// Data de cria: 31-X-2002
// Data da ltima actualiza: 25-XII-2002
// Autor: Xos B. Carballeira Rabual

#local versionRelevo=version;
#version 3.5;

/****************************************** INSTRUES *****************************************************

               **HAI-NAS QUE ESCREVER**

*************************************************************************************************************/

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Relevo.inc\", que ajuda a criar mapas de relevo.\n"
#end

global_settings{
  assumed_gamma 1
  ambient_light 1
}

#ifndef(Relevo_TipoDeCamara)
  #declare Relevo_TipoDeCamara=0;  //Perspectiva
#end

//Todo este conhao para encher os dados omitidos.
#if(defined(Relevo_Largo)&defined(Relevo_Alto)&defined(Relevo_Focal))
  #declare Xose_SRDextrogiro=(vdot(Relevo_Largo,vcross(Relevo_Alto,Relevo_Focal))<0);
#else
  #ifndef(Xose_SRDextrogiro)
    #declare Xose_SRDextrogiro=false;
  #end
  #ifdef(Relevo_Largo)
    #ifdef(Relevo_Alto)
      #local Raskanderzlats=(Xose_SRDextrogiro? 1: -1)*vcross(Relevo_Alto,Relevo_Largo);
      #if(vlength(Raskanderzlats)=0)
        #declare Raskanderzlats=vcross((Xose_SRDextrogiro? z: -y),Relevo_Largo);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=(Xose_SRDextrogiro? y: z);
        #end
      #end
      #declare Relevo_Focal=9/4*vlength(Relevo_Largo)*vnormalize(Raskanderzlats);
    #else
      #ifdef(Relevo_Focal)
        #local Raskanderzlats=(Xose_SRDextrogiro? 1: -1)*vcross(Relevo_Largo,Relevo_Focal);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=vcross( Relevo_Largo,
            vcross((Xose_SRDextrogiro? z: y),Relevo_Largo) );
          #if(vlength(Raskanderzlats)=0)
            #declare Raskanderzlats=select(vdot((Xose_SRDextrogiro? z: y),Relevo_Largo),1,-1)*x;
          #end
        #end
        #declare Relevo_Alto=3/4*vlength(Relevo_Largo)*vnormalize(Raskanderzlats);
      #else
        #local Raskanderzlats=vcross((Xose_SRDextrogiro? z: -y),Relevo_Largo);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=(Xose_SRDextrogiro? y: z);
        #end
        #declare Relevo_Focal=9/4*vlength(Relevo_Largo)*vnormalize(Raskanderzlats);
        #declare Relevo_Alto=3/4*(Xose_SRDextrogiro? 1: -1)*vlength(Relevo_Largo) *
          vnormalize(vcross(Relevo_Largo,Raskanderzlats));
      #end
    #end
  #else
    #ifdef(Relevo_Alto)
      #ifdef(Relevo_Focal)
        #local Raskanderzlats=(Xose_SRDextrogiro? 1: -1)*vcross(Relevo_Focal,Relevo_Alto);
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=vcross(Relevo_Alto,(Xose_SRDextrogiro? z: -y));
          #if(vlength(Raskanderzlats)=0)
            #declare Raskanderzlats=x;
          #end
        #end
        #declare Relevo_Largo=4/3*vlength(Relevo_Alto)*vnormalize(Raskanderzlats);
      #else
        #local Raskanderzlats=vcross(Relevo_Alto,(Xose_SRDextrogiro? z: -y));
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=x;
        #end
        #declare Relevo_Largo=4/3*vlength(Relevo_Alto)*vnormalize(Raskanderzlats);
        #declare Relevo_Focal=3*(Xose_SRDextrogiro? 1: -1)*vlength(Relevo_Alto) *
          vnormalize(vcross(Relevo_Alto,Raskanderzlats));
      #end
    #else
      #ifdef(Relevo_Focal)
        #local Raskanderzlats=vcross(Relevo_Focal,(Xose_SRDextrogiro? z: -y));
        #if(vlength(Raskanderzlats)=0)
          #declare Raskanderzlats=x;
        #end
        #declare Relevo_Largo=4/9*vlength(Relevo_Focal)*vnormalize(Raskanderzlats);
        #declare Relevo_Alto=(Xose_SRDextrogiro? 1: -1)/3*vlength(Relevo_Focal)*
          vnormalize(vcross(Raskanderzlats,Relevo_Focal));
      #else
        #declare Relevo_Largo=4/3*x;
        #declare Relevo_Alto=(Xose_SRDextrogiro? z: y);
        #declare Relevo_Focal=3*(Xose_SRDextrogiro? y: z);
      #end
    #end
  #end
#end

#ifndef(Relevo_UbiCamara)
  #if(Xose_SRDextrogiro)
    #declare Relevo_UbiCamara=-y;
  #else
    #declare Relevo_UbiCamara=-z;
  #end
#end
#ifndef(Relevo_CeuCamara)
  #if(Xose_SRDextrogiro)
    #declare Relevo_CeuCamara=z;
  #else
    #declare Relevo_CeuCamara=y;
  #end
#end
#if(defined(Relevo_AngCamara)&(Relevo_TipoDeCamara<2))
  #declare Relevo_Focal=vlength(Relevo_Largo)/(2*tan(Relevo_AngCamara/2))*vnormalize(Relevo_Focal);
#end

camera{
  #switch(Relevo_TipoDeCamara)
    #case(0)
      perspective
    #break
    #case(1)
      orthographic
    #break
    #case(2)
      fisheye
    #break
    #case(3)
      ultra_wide_angle
    #break
    #case(4)
      omnimax
    #break
    #case(5)
      panoramic
    #break
    #case(6)
      cylinder 1
    #break
    #case(7)
      cylinder 2
    #break
    #case(8)
      cylinder 3
    #break
    #case(9)
      cylinder 4
    #break
    #case(10)
      spherical
    #break
  #end
  location Relevo_UbiCamara
  right Relevo_Largo
  up Relevo_Alto
  direction Relevo_Focal
  sky Relevo_CeuCamara
  #ifdef(Relevo_AngCamara)
    angle Relevo_AngCamara
  #end
  #if((Relevo_TipoDeCamara=10)&defined(Relevo_AngCamara2))
    angle Relevo_AngCamara2.u, Relevo_AngCamara2.v
  #end
  #ifdef(Relevo_OlhaCara)
    look_at Relevo_OlhaCara
  #end
}

#ifdef(Relevo_OlhaCara)
  #local DirMir=vnormalize(Relevo_OlhaCara-Relevo_UbiCamara);
#else
  #local DirMir=vnormalize(Relevo_Focal);
#end
#local DirMirX=DirMir.x;
#local DirMirY=DirMir.y;
#local DirMirZ=DirMir.z;

#if((Relevo_TipoDeCamara=1)&defined(Relevo_OlhaCara))
  #local DistanciaFocal=vlength(Relevo_OlhaCara-Relevo_UbiCamara);
  #local PtoDoQuadro=Relevo_OlhaCara;
#else
  #local DistanciaFocal=vlength(Relevo_Focal);
  #local PtoDoQuadro=Relevo_UbiCamara+Relevo_Focal;
#end
#local PtoDoQuadroX=PtoDoQuadro.x;
#local PtoDoQuadroY=PtoDoQuadro.y;
#local PtoDoQuadroZ=PtoDoQuadro.z;

#local Relevo_UbiCamaraX=Relevo_UbiCamara.x;
#local Relevo_UbiCamaraY=Relevo_UbiCamara.y;
#local Relevo_UbiCamaraZ=Relevo_UbiCamara.z;

#if((Relevo_TipoDeCamara=2)|(Relevo_TipoDeCamara=3)|(Relevo_TipoDeCamara=4)|(Relevo_TipoDeCamara=10))
  #local Fonfon=function{
    (sqrt(pow(x-Relevo_UbiCamaraX,2)+pow(y-Relevo_UbiCamaraY,2)+pow(z-Relevo_UbiCamaraZ,2)) - 
      DistanciaFocal) /
    sqrt(pow(x-Relevo_UbiCamaraX,2)+pow(y-Relevo_UbiCamaraY,2)+pow(z-Relevo_UbiCamaraZ,2))
  }
#else
  #if((Relevo_TipoDeCamara>=6)&(Relevo_TipoDeCamara<=9))
    #if((Relevo_TipoDeCamara=6)|(Relevo_TipoDeCamara=8))
      #local Jacarandaina=vnormalize(Relevo_Alto);
    #else
      #local Jacarandaina=vnormalize(Relevo_Largo);
    #end
    #local JacarandainaX=Jacarandaina.x;
    #local JacarandainaY=Jacarandaina.y;
    #local JacarandainaZ=Jacarandaina.z;
    #local Fonfon=function{
      (sqrt(pow(x-Relevo_UbiCamaraX,2)+pow(y-Relevo_UbiCamaraY,2)+pow(z-Relevo_UbiCamaraZ,2) - 
          pow(JacarandainaX*(x-Relevo_UbiCamaraX)+JacarandainaY*(y-Relevo_UbiCamaraY) +
            JacarandainaZ*(z-Relevo_UbiCamaraZ),2)) - 
        DistanciaFocal) /
      sqrt(pow(x-Relevo_UbiCamaraX,2)+pow(y-Relevo_UbiCamaraY,2)+pow(z-Relevo_UbiCamaraZ,2) - 
          pow(JacarandainaX*(x-Relevo_UbiCamaraX)+JacarandainaY*(y-Relevo_UbiCamaraY) +
            JacarandainaZ*(z-Relevo_UbiCamaraZ),2))
    }
  #else
    #local Fonfon=function{
      (DirMirX*(x-PtoDoQuadroX)+DirMirY*(y-PtoDoQuadroY)+DirMirZ*(z-PtoDoQuadroZ)) /
        (DistanciaFocal+DirMirX*(x-PtoDoQuadroX)+DirMirY*(y-PtoDoQuadroY)+DirMirZ*(z-PtoDoQuadroZ))
    }
  #end
#end

#ifdef(Relevo_MaxRel)
  #local MinFonfon=1-Relevo_MaxRel;
#else
  #ifdef(Relevo_MinFund)
    #local MinFonfon=Relevo_MinFund/(DistanciaFocal+Relevo_MinFund);
  #else
    #local MinFonfon=0;
  #end
#end
#ifdef(Relevo_MinRel)
  #local MaxFonfon=1-Relevo_MinRel;
#else
  #ifdef(Relevo_MaxFund)
    #local MaxFonfon=Relevo_MaxFund/(DistanciaFocal+Relevo_MaxFund);
  #else
    #local MaxFonfon=1;
  #end
#end

#ifndef(Relevo_ExpoenteLonge)
  #declare Relevo_ExpoenteLonge=1;
#end
#ifndef(Relevo_ExpoentePerto)
  #declare Relevo_ExpoentePerto=1;
#end
#ifndef(Relevo_FactorLonge)
  #declare Relevo_FactorLonge=1;
#end
#ifndef(Relevo_FactorPerto)
  #declare Relevo_FactorPerto=1;
#end

#declare Relevo_Tex=texture{
  pigment{
    function{pow(max(Relevo_FactorPerto*(1-pow(max(Relevo_FactorLonge *
      (Fonfon(x,y,z)-MinFonfon)/(MaxFonfon-MinFonfon),0),
      Relevo_ExpoentePerto)),0),Relevo_ExpoenteLonge)
    }
  }
  finish{ambient 1 diffuse 0}
}

#default{texture{Relevo_Tex}}

#declare Xose_SemTexturas=true;

#version versionRelevo;