// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Terra realista.pov
// Vers: 3.5
// Descri: Representa da Terra mediante umha esfera gigantesca, em metros
// Data: Comeos do 2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

camera{ fisheye
  location 0
  rotate<-90,-90,0>
  translate<0,6378000+1.6,0>
  rotate <0,0,52> 
  angle 200
  //look_at <0,6378000+1.6,0> 
  //normal{bozo turbulence 1 octaves 3}
}

   

//=========================== A Terra ====================================
//Corpo
sphere{<0,0,0>, 6378000     
 texture{
  pigment{agate 
    agate_turb .2
    color_map
    {[0 rgb<.8,.3,.1>]
     [.4 rgb<.7,.5,.06>]
     [.5 rgb<.2,.8,.7>]
     [.55 rgb<.7,.4,.1>]
     [.8 rgb<.5,.4,.1>]
     [.9 rgb<.96,.7,.4>]
     [1 rgb<.8,.3,.1>]
    } 
    scale 5
  }
  normal{
    bumps   bump_size .1
    scale 2
  }
 } 
}
//Atmosfera
sphere{0,  6378000+1000   
  hollow
  pigment{rgbf 1}
  interior{
    //fade_distance 1000  fade_power 2
    media{
      scattering{4,.1*<.01,.1,1>}
      density{
        spherical color_map{
         [0 rgb 0]
         [986/6379000 rgb .2]
         [988/6379000 rgb .7]
         [1000/6379000 rgb 1]
        }
      }
    } 
  }
} 

//=================================== O Sol ============================================
light_source{0 color rgb <1,1,.8>
  area_light <0,0, 1130471066.108>, <0, 1130471066.108,0>,3,3 
  fade_distance 150e9 fade_power 2 
  media_attenuation on
  looks_like{
    sphere{0, 637800000
      scale 235.159884755        //Isto  para corrigir o misterioso problema do tamanho do Sol.
      pigment{bozo color_map{
        [0 rgb<.5,.5,0>]
        [.1 rgb<1,.3,0>]
        [.6 rgb<1,1,.2>]
        [.8 rgb<1,1,.3>]
        [.9 rgb<.9,1,.2>]
        [1 rgb<1,1,.3>]
        }
        turbulence .3
        octaves 10
        lambda .3
        omega .8
        scale 8e5

        scale .02               //Isto , tambm, para corrigir o problema do tamanho do Sol.
      }
      finish{ambient 1}

    }
   }
  translate <-150e9,0,0>
}