// Arquivo auxiliar para o traador de raios de Persistence of Vision
// Arquivo: Texturas humanas.inc
// Vers: 3.5
// Descri: Vrias cores para a pele, o cabelo e mais os olhos das figuras Blob Man. Precisam
  //assumed_gamma 1.
// Data de cria: 15-X-2002
// Data da ltima actualiza: 19-VI-2003
// Autor: Xos B. Carballeira Rabual

#local versionPelCabOllos=version;
#version 3.5;

#ifndef(Xose_Mensagens)
  #declare Xose_Mensagens=false;
#end

#if(Xose_Mensagens)
  #debug "    Esta-se a executar o arquivo \"Texturas humanas.inc\", que define cores para a pele, o cabelo e mais os olhos das figuras \"Blob Man\".\n"
#end


//--------------------------------------------------- Pele -------------------------------------------------------

// Utilize-se a macro BM_CorDaPele com umha das seguintes cores de parmetro.

#declare PeleAlbina=rgb<.99,.82,.8>;
#declare PeleAmarela=rgb<.82,.78,.45>;
#declare PeleBrancaPalida=rgb<.85,.68,.48>;
#declare PeleBranca=rgb<.793,.456,.325>;
#declare PeleRoxa=rgb<.75,.25,.11>;
#declare PeleMorena=rgb<.4,.18,.1>;
#declare PeleMulata=rgb<.2,.06,.02>;
#declare PeleNegra=rgb<.072,.022,.01>;

#macro BM_CorDaPele(Cor)
  #declare BM_Skin_Tex=texture{pigment{Cor} finish{phong .1 phong_size 40}}
#end


//-------------------------------------------------- Olhos ------------------------------------------------------

// Valores para a varivel BM_EyeCol

#declare OlhosVermelhos=<1,.1,0>;  //Como nalgumhas fotos
#declare OlhosVerdes=<.12,.92,.3>;
#declare OlhosAzuis=<.22,.69,.87>;
#declare OlhosMarrons=<.25,.25,0>;
#declare OlhosNegros=<.06,.05,.02>;


//------------------------------------------------- Cabelo --------------------------------------------------------------

// Assignando a BM_Hair_Col um dos seguintes valores, obter-se- um plo de cor varivel, com cada componente
//vermelha, verde e azul igual  que corresponda do vector en quest, mais umha quantidade aleatria
//entre 0 e 0'1. Para lograr um cabelo de cor uniforme, empregue-se a macro BM_CorDoPelo com o vector dese-
//jado como parmetro.

#declare PeloNegro=<.02, .016, .004>;
#declare PeloCastanhoEscuro=<.29, .08, .01>;
#declare PeloCastanhoClaro=<.4, .13, .02>;
#declare PeloRoxo=<.65, .12, .03>;
#declare PeloLoiroDouradoCobrico=<.65, .26, .05>;
#declare PeloLoiroClaro=<.68, .37, .05>;
#declare PeloDecolorado=<.7, .5, .1>;  //Com auga oxigenada, por exemplo.
#declare PeloGris=<.5, .4, .3>;
#declare PeloBranco=<.95, .85, .75>;

#macro BM_CorDoPelo(Cor)
  #declare BM_Hair_Tex=texture{pigment{rgb Cor}}
#end


#version versionPelCabOllos;