// Arquivo principal de cena para o traador de raios de Persistence of Vision
// Arquivo: Qual?.pov
// Vers: 3.6
// Descri: Tres esporas
// Data de cria: 8-XI-2005
// Data da ltima actualiza: 22-XI-2005
// Autor: Xos B. Carballeira Rabual

// +w600 +h140 +kff3 +kc +ua

#version 3.6;

global_settings{
  assumed_gamma 1
  max_trace_level 25
}

camera{
  location<0,.1,-.6>
  right .06*x
  up .014*y
  direction .6*z
  look_at 0
}

light_source{1e7*y rgb 1 rotate<-64.76,45,0>}

#declare Espora=union{
  torus{.003, .001 rotate 90*x scale<1,1,.003/.004> translate -.0005*z}
  torus{.003, .001 rotate 90*x scale<1,1,.003/.004> translate .0005*z}
  difference{
    cylinder{-.0005*z, .0005*z, .004}
    cylinder{-.0006*z, .0006*z, .002}
  }
  #declare ContaPontas=0;
  #while(ContaPontas<9)
    julia_fractal{<-.5,.4,.4,0> quaternion sqr max_iteration 50 precision 50 rotate 120*z
      scale .0013 translate .0037*y rotate 360*ContaPontas/9*z
    }
    #declare ContaPontas=ContaPontas+1;
  #end
  rotate 360/9*clock*z
  texture{
    pigment{rgb<.7,.8,1>}
    //normal{dents .5 scale .01}
    finish{
      brilliance 1.5
      specular .8 roughness 1/500 metallic
      reflection{.5,.9 metallic}
    }
  }
}

object{Espora}
object{Espora translate -.02*x}
object{Espora translate .02*x}

#declare AgochaFundo=disc{<0,-.0084,.05>, -z, .0065, .003 pigment{rgb 0} finish{diffuse 0 ambient 0}}
object{AgochaFundo}
object{AgochaFundo translate -.0215*x}
object{AgochaFundo translate .0215*x}
