// Arquivo principal de cena para o traador de raios de persistence of vision
// Arquivo: Vaso de precipitados.pov
// Vers: 3.5
// Descri: Vaso de precipitados com um lquido vermelho fervendo e mais umha varinha de vidro
// Data: Finais do 2001, actualizado no primeiro semestre do 2002
// Autor: Xos B. Carballeira Rabual

#version 3.5;

#include "colors.inc"	
#include "textures.inc"	

camera{
  location  <0.0, 6, -15>
  look_at   <0.0, 2,  0.0>
  angle 30
}

global_settings{
  assumed_gamma 1
  ambient_light 0.3
  max_trace_level 100
}

light_source{ 0*x   color rgb <1,1,.8> translate <-200, 400, -200>}

background { color red 1 green 1 blue 1 }

difference{
  cylinder{ 0*y,  3*y,  1.5 }
  cylinder{.2*y, 3.1*y,1.4}
  pigment{rgbf <.8,1,.4,1>}
  finish{
    specular .9 roughness .001
    reflection .1
  }
  interior{ior 1.5
  }
}

merge{
  cylinder{.201*y, 1.8*y, 1.399 } 
  difference{
    sphere{<.2,1.8,-.4> .3}
    sphere{<.2,1.8,-.4> .29}
  }
  difference{
    sphere{<-.3,1.8,1.2> .3}
    sphere{<-.3,1.8,1.2> .29}
  }
  difference{
    sphere{<-.1,1.8,-.9> .4}
    sphere{<-.1,1.8,-.9> .39}
  }
  difference{
    sphere{<-.3,1.8,-1.1> .2}
    sphere{<.2,1.8,-.4> .19}
  }
  pigment{rgbf <1,.01,.01,1>}
  finish{
    specular .7 roughness .005
  }
  interior{ior 1.33
  }
}
cylinder{.2*y <2,4.4,0> .1
  rotate <0,-32,0>
  pigment{rgbf<0,.2,.8,.6>}
  finish{
    specular .9 roughness .001
    reflection .1
  }
  interior{ior 1.5}
}

/*#declare StrengthVal = 1.0; // (+ or -) strength of component's radiating density
#declare RadiusVal   = .3; // (0 < RadiusVal) outer sphere of influence on other components
blob
{
  // threshold (0.0 < threshold <= StrengthVal) surface falloff threshold #
  threshold 0.05  //.6
  sphere { < 0.75,   3.5,    0>, StrengthVal, RadiusVal }
  sphere { <-0.375,  3.65, 1>, StrengthVal, RadiusVal }
  sphere { <-0.375, 4.02, -.5>, StrengthVal, RadiusVal }
  sphere { < 0.9,   4.5,    .4>, StrengthVal, RadiusVal }
  sphere { <-1.2,  4.65, -.4>, StrengthVal, RadiusVal }
  sphere { <-0.375, 2.8, -.5>, StrengthVal, RadiusVal }
  sphere { < 0.75,   4.8,    0>, StrengthVal, RadiusVal }
  sphere { <-0.9,  4.2, 1.3>, StrengthVal, RadiusVal }
  sphere { <0.4, 4.02, -.5>, StrengthVal, RadiusVal }
  sphere { < .5,   4.5,    .4>, StrengthVal, RadiusVal }
  sphere { <1,  3.6, 0>, StrengthVal, RadiusVal }
  sphere { <0.375, 4.8, -.5>, StrengthVal, RadiusVal }  
  // [sturm]
pigment{rgbt<.8,.4,.3,.8>} rotate<0,-30,0>}
*/

cylinder{<0,0,0>,<0,20,0>,150
  hollow
  pigment{rgbf 1}
  interior{
    media{
      absorption <.01,.2,.1>
      scattering{2,<0.02,.25,.5>}
      density{
        gradient y
        density_map{
          [0 cylindrical colour_map{[0 rgb 0] [1 rgb 2]} turbulence .3 scale 1.3]
          [1.4/20 cylindrical colour_map{[0 rgb 0] [1 rgb 1.5]}  turbulence .2 scale 1.5]
          [1.6/20 cylindrical turbulence .2 scale 2.5]
          [2.5/20 spherical turbulence .5 scale 4 translate <0,2,0>]
        }
        scale<1,20,1>
      }
    }
  }
  translate<0,1.801,0>
}